      SUBROUTINE BCGPS(ID,ICELL,VPOS,IERR)
*.
*..BCGPS     Get Barrel Cal position vector
*.
*. INPUT     : ID       : =1 EM
*.                        =2 HAD
*.             ICELL    : Cell ID 
*.
*. OUTPUT    : VPOS(1)  : X
*.                 (2)  : Y
*.                 (3)  : Z
*.                 (4)  : R
*.                 (5)  : Theta
*.                 (6)  : Phi
      
      IMPLICIT NONE

      INTEGER ID,ICELL,IERR
      REAL VPOS(6), X,Y,Z,R,TH,FI
      CHARACTER*1  MODE

      IF(ID.EQ.2) THEN
         MODE = 'H'
         CALL BCPOS(ICELL,MODE,X,Y,Z,TH,FI)
      ELSE
         MODE = 'E'
         CALL BCPOS(ICELL,MODE,X,Y,Z,TH,FI) 
      ENDIF

      R = SQRT(X**2 + Y**2)

      VPOS(1) = X
      VPOS(2) = Y
      VPOS(3) = Z
      VPOS(4) = R
      VPOS(5) = TH
      VPOS(6) = FI

      IERR = 0

      RETURN
      END


