      SUBROUTINE ECOUT
*.
*...ECOUT    Called once at the end of event and clustering.......
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : GUOUT
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 24-May-1995
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
*.
*.*********************************************************************
*.     +------------------------+                                     *
*.     | Bank Name  :  MCE?CLUS |                                     *
*.     +------------------------+                                     *
*.                                                                    *
*.     Contents    : List of Barrel Calorimeter hits on tracks which  *
*.                   the JIM generated.                               *
*.     Record Type : 1-dim. variable length segment                   *
*.     Version     : Release 1.0  1995-Apr-21                         *
*.                                                                    *
*.*********************************************************************
*.
*.(1) Contents in the Master Segment
*.----------------------------------
*.
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. IDATA(1)      # of clusters
*. IDATA(2)      # of charged cluster
*. IDATA(3)      # of neutral cluster
*. IDATA(4)      ID of clustering program
*. RDATA(5)      Total Energy of All clusters
*. RDATA(6-11)   Clustering parameters
*.----------------------------------------------------------------------
*.
*.(Note)
*.   Master segment = segment # 0
*.
*.
*.(2) Contents in the Data Segment
*.--------------------------------
*. # of Data Segment = # of clusters + 1(master segment)
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. RDATA(1)      Energy of the cluster
*. RDATA(2)      Ex/E
*. RDATA(3)      Ey/E
*. RDATA(4)      Ez/E
*. IDATA(5)      # hit cell ( N cells )
*. IDATA(6)      # of matched CDC tracks ( M tracks )
*. IDATA(7)    |
*.    -        + Contributed cell ID#
*. IDATA(6+N)  |
*. IDATA(7+N)  |
*.    -        + Contributed CDC Track ID
*. IDATA(6+N+M)|
*.----------------------------------------------------------------------
*. Length of Data Segment = 6+N+M
*.**********************************************************************
      
      IMPLICIT NONE

#include "ecgeo.inc"

      REAL CLSPEC(5,2)

      INTEGER NMXDT,LNGBKE
      PARAMETER(NMXDT  = 2000)
      PARAMETER(LNGBKE = 1000)
      INTEGER NDR(2),NDPH(2)
      INTEGER NHTDAT(2),BNKIDX(NMXDT,2),NUMCLS(2)
      INTEGER NCLSPT(2,NMXDT,2),CLSIDX(NMXDT,2)
      REAL RHDAT(3,NMXDT,2),SRTKY(NMXDT,2)
      REAL CLSPS1(3),CLSPS3(3),VECT(6)
      INTEGER ITRDAT(NMXDT),NCLS

      REAL RBKDAT(LNGBKE,NMXDT,2)
      INTEGER IBKDAT(LNGBKE,NMXDT,2)
      EQUIVALENCE(RBKDAT(1,1,1),IBKDAT(1,1,1))

      REAL    RDATA(LNGBKE)
      INTEGER IDATA(LNGBKE),NDATA
      EQUIVALENCE(IDATA(1),RDATA(1))

      CHARACTER*32 CIBNK(2),COBNK(2)
      DATA CIBNK/ 'MCEEHIT ' , 'MCEHHIT ' /
      DATA COBNK/ 'MCEECLUS' , 'MCEHCLUS' /

      INTEGER ID,NSEG,ISEG,NSSEG,IZE,IT,I,IER,NCEL,NCTRAK
      INTEGER IERR,IVECT,ICTR,NCTR,ISTART,NCT
      REAL ESUM
      

      IF(SWITEC.NE.2) THEN
         CALL MSGOUT('ECOUT',
     &        'EC clustering is not available for ECSWIT != 2',SWITEC) 
         RETURN
      END IF

      NDR(1)  = NDREC*2
      NDR(2)  = NDREC
      NDPH(1) = NDPEC(1)*2
      NDPH(2) = NDPEC(1)

      DO 1000 ID=1,2

*-- (1)Start EM Part

*-- 1. GET Master Segment DATA of Bank MCEEHIT
         CALL KZNSEG(CIBNK(ID),NSEG)
         CALL KZGET(CIBNK(ID),0,NDATA,IDATA)

*-- 2. Get Secondary Segment DATA of Bank MCEEHIT
         NDATA = NSEG
         CALL VZERO(NHTDAT,2)
         DO 10 ISEG = 1,NDATA
            CALL KZGET(CIBNK(ID),ISEG,NSSEG,RDATA)
            IF(IDATA(1).GT.0) THEN
               IZE = 1
            ELSE IF(IDATA(1).LT.0) THEN
               IZE = 2
            END IF
            IF(ID.EQ.1) THEN
               NHTDAT(IZE) = NHTDAT(IZE) + 1
               SRTKY(NHTDAT(IZE),IZE)  =  RDATA(2)
               IBKDAT(1,NHTDAT(IZE),IZE) = IABS(IDATA(1))
               RBKDAT(2,NHTDAT(IZE),IZE) = RDATA(2)
               RBKDAT(3,NHTDAT(IZE),IZE) = RDATA(3)
               IBKDAT(4,NHTDAT(IZE),IZE) = IDATA(4)
               DO 11 IT = 1,IBKDAT(4,NHTDAT(IZE),IZE)
                  IBKDAT(4+IT,NHTDAT(IZE),IZE) = IDATA(3*IT+2)
 11            CONTINUE
            ELSE
               NHTDAT(IZE) = NHTDAT(IZE) + 1
               SRTKY(NHTDAT(IZE),IZE)  =  RDATA(2)+RDATA(3)
               IBKDAT(1,NHTDAT(IZE),IZE) = IABS(IDATA(1))
               RBKDAT(2,NHTDAT(IZE),IZE) = RDATA(2)+RDATA(3)
               RBKDAT(3,NHTDAT(IZE),IZE) = RDATA(4)
               IBKDAT(4,NHTDAT(IZE),IZE) = IDATA(5)
               DO 12 IT=1,IBKDAT(4,NHTDAT(IZE),IZE)
                  IBKDAT(4+IT,NHTDAT(IZE),IZE) = IDATA(4*IT+2)
 12            CONTINUE
            END IF
 10      CONTINUE

*-- 3. Sort DATA according to Energy
         DO 20 IZE = 1,2
            CALL SORTZV
     &           (SRTKY(1,IZE),BNKIDX(1,IZE),NHTDAT(IZE),1,1,0)
            DO 21 I=1,NHTDAT(IZE)
               RHDAT(1,I,IZE) = FLOAT(IBKDAT(1,BNKIDX(I,IZE),IZE))
               RHDAT(2,I,IZE) = RBKDAT(2,BNKIDX(I,IZE),IZE)
               RHDAT(3,I,IZE) = RBKDAT(3,BNKIDX(I,IZE),IZE)
 21         CONTINUE
 20      CONTINUE

*-- 4. Main Clustring Routine
         CALL BCCLSR(RHDAT(1,1,1),NHTDAT(1),NDR(ID),NDPH(ID),
     &        CLSPEC(1,ID),NMXDT,NUMCLS(1),NCLSPT(1,1,1),CLSIDX(1,1))
         CALL BCCLSR(RHDAT(1,1,2),NHTDAT(2),NDR(ID),NDPH(ID),
     &        CLSPEC(1,ID),NMXDT,NUMCLS(2),NCLSPT(1,1,2),CLSIDX(1,2))

*-- 5. Create Bank ( 1-dim Free Format Type. )
         CALL KZBCR0(COBNK(ID),IER)

*-- 6.Fill Master Segment
         ESUM = 0.
         NCLS = 0
         IDATA(1)  = NUMCLS(1)+NUMCLS(2)
         IDATA(2)  = NUMCLS(1)
         IDATA(3)  = NUMCLS(2)
         IDATA(4)  = 0
         CALL KZREP0(COBNK(ID),0,'I',4,IDATA)
         DO 300 IZE = 1,2
            DO 30 ISEG=1,NUMCLS(IZE)
               NCLS   = NCLS + 1
               NCEL   = 0
               NCTRAK  = 0
               CALL VZERO(RDATA,LNGBKE)
               CALL VZERO(CLSPS1,3)
               IDATA(5) = NCLSPT(2,ISEG,IZE)-NCLSPT(1,ISEG,IZE)+1
               DO 31 I=NCLSPT(1,ISEG,IZE),NCLSPT(2,ISEG,IZE)
                  ESUM = ESUM + RHDAT(2,I,IZE)
                  NCEL = NCEL + 1
                  RDATA(1) = RDATA(1) + RHDAT(2,I,IZE)
                  IF(IZE.EQ.1) THEN
                     IDATA(5+NCEL)=INT(RHDAT(1,I,IZE))
                  ELSE IF(IZE.EQ.2) THEN
                     IDATA(5+NCEL)=-1*INT(RHDAT(1,I,IZE))
                  END IF

*-- 7.Energy Weighted Cluster Position
                  CALL ECGPS(ID,IDATA(5+NCEL),VECT,IERR)

                  DO 32 IVECT = 1,3
                     CLSPS1(IVECT) = CLSPS1(IVECT) + 
     &                    VECT(IVECT)*RHDAT(2,I,IZE)**CLSPEC(5,ID)
 32               CONTINUE

*-- 8. Store Contributed Trak ID
                  ICTR = BNKIDX(CLSIDX(I,IZE),IZE)
                  NCTR = IBKDAT(4,ICTR,IZE)
                  DO 33 IT=1,NCTR
                     NCTRAK=NCTRAK+1
                     ITRDAT(NCTRAK) = IBKDAT(4+IT,ICTR,IZE)
 33               CONTINUE
 31            CONTINUE

*--  Remove Duplicated Charged Track ID # 
               NCT = 0
               ISTART=0
 35            CONTINUE
               ISTART = ISTART +1
               NCT = NCT + 1
               IF(ISTART.GT.NCTRAK) THEN
                  NCT = NCT - 1
                  GOTO 36
               END IF
               IF(ITRDAT(ISTART).EQ.0) THEN
                  NCT = NCT -1
                  GOTO 35
               END IF
               DO 34 IT = ISTART+1,NCTRAK
                  IF(ITRDAT(IT).EQ.ITRDAT(ISTART)) ITRDAT(IT)=0
 34            CONTINUE
               ITRDAT(NCT) = ITRDAT(ISTART)
               GOTO 35
 36            CONTINUE

*-- Fill Particle to Detector Pointer
               CALL VUNIT(CLSPS1,CLSPS3,3)
               
               RDATA(2)      = CLSPS3(1)
               RDATA(3)      = CLSPS3(2)
               RDATA(4)      = CLSPS3(3)
               IDATA(6+NCEL) = NCT
               CALL KZREP0(COBNK(ID),NCLS,'F',4,RDATA(1))
               CALL KZREP0(COBNK(ID),NCLS,'I',1,NCEL)
               CALL KZREP0(COBNK(ID),NCLS,'I',1,NCT)
               CALL KZREP0(COBNK(ID),NCLS,'I',NCEL,IDATA(6))
               CALL KZREP0(COBNK(ID),NCLS,'I',NCT,ITRDAT)

 30         CONTINUE
 300     CONTINUE
         RDATA(1) = ESUM
         RDATA(2) = CLSPEC(1,ID)
         RDATA(3) = CLSPEC(2,ID)
         RDATA(4) = CLSPEC(3,ID)
         RDATA(5) = CLSPEC(4,ID)
         RDATA(6) = CLSPEC(5,ID)
         CALL KZREP0(COBNK(ID),0,'F',6,RDATA)

 1000 CONTINUE

      RETURN
      END
