      SUBROUTINE CTANAL
*.
*...CTANAL   Analyze central tracker hits and store results into the
*.           bank 'TRACK'
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : CTGEO  GCNUM
*. CALLS     : KZGET1 KZGET0
*. CALLED    : GUANAL
*.
*. BANKS L   : CTTRACK
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Junichi KANZAKI
*. VERSION   : 1.00
*. CREATED   : 13-Mar-1996
*. LAST MOD  : 08-Sep-1998 Y.Fujii ; 0-division by RADRPH fixed.
*.
*. MODIFICATION LOG
*.**********************************************************************
      IMPLICIT NONE

*--   Common
#include "jlcnst.inc"
#include "ctgeo.inc"

*--   Parameter for bank 'CTTRACK'
      CHARACTER*32 CFMCTR,CFSCTR
      INTEGER NWMCTR,LSECTR,LSDCTR,IERCTR
      PARAMETER (NWMCTR=1)
      PARAMETER (CFMCTR='1I')
      PARAMETER (LSECTR=44)
      PARAMETER (LSDCTR=LSECTR/2)
      PARAMETER (CFSCTR='4F 1I 3F 1I 3F 2I 30D') 
      REAL RDACTR(LSECTR)
      DOUBLE PRECISION DDACTR(LSDCTR)
      INTEGER IDACTR(LSECTR)
      EQUIVALENCE (RDACTR(1),IDACTR(1))
      EQUIVALENCE (DDACTR(1),IDACTR(1))

*--   Parameter for the bank 'MCCTHIT-TRACK'
      INTEGER NTRCTT

      INTEGER NCTTRK

      INTEGER NHITS

      INTEGER IHINF,NHINF
      INTEGER IHANO,NHANO,NHBAS
      INTEGER NHTOT

      INTEGER NDATA,NPDATA
      PARAMETER (NPDATA=30)
      INTEGER IDATA(NPDATA)
      REAL RDATA(NPDATA)
      EQUIVALENCE (IDATA(1),RDATA(1))

      REAL X0,Y0,Z0
      
      INTEGER IADDR,ITR,IHTNUM,IWIRE
      INTEGER IDET,ILAY,ICEL

      INTEGER NRPH,NRZ
      INTEGER IRDMIN
      INTEGER NFRRPH,NFRRZ
      INTEGER NHMAX
      PARAMETER (NHMAX=3000)
      REAL XRPH(NHMAX),YRPH(NHMAX),ZRPH(NHMAX),SRPH(NHMAX)
      REAL XRPH0(NHMAX),YRPH0(NHMAX),ZRPH0(NHMAX),SRPH0(NHMAX)
      REAL TRPH0(NHMAX)
      REAL SIGXY
      PARAMETER (SIGXY=0.010)
      REAL XRZ(NHMAX),YRZ(NHMAX),ZRZ(NHMAX),SRZ(NHMAX),DRZ(NHMAX)
      REAL XRZ0(NHMAX),YRZ0(NHMAX),ZRZ0(NHMAX),DRZ0(NHMAX)
      REAL TRZ0(NHMAX)
      REAL SIGZ
C      PARAMETER (SIGZ=0.100)
      INTEGER LSORT(NHMAX)
      REAL CHI

      REAL SGNRPH,RADRPH,PH0RPH,RMNRPH
      DOUBLE PRECISION ERMRPH(3,3)
      REAL RSIRPH(NHMAX),CHIRPH

      REAL PHIMIT,XCENT,YCENT,RDIST
      INTEGER ITURN
      REAL SL0,SL1,SL2

      REAL ZMNRZ,DZSRZ
      DOUBLE PRECISION ERMRZ(2,2)
      REAL RSIRZ(NHMAX),CHIRZ

      INTEGER ITSTAK
      PARAMETER (ITSTAK=10000)
      INTEGER ITRAK

      INTEGER I

      REAL TOF,TOFCUT
      PARAMETER (TOFCUT=20.)

      REAL PMOM(5),costh,phi,pp,pt
      INTEGER ICHARG,IFLAG
      
      integer j

      
      CALL KZGET('MCCTHIT-TRACK',0,NDATA,NTRCTT)

      NCTTRK = 0
      DO 10 ITR=1,NTRCTT
         CALL KZGET('MCCTHIT-TRACK',ITR,NDATA, NHITS)
         IF (NHITS.GE.0) THEN
            NCTTRK=NCTTRK+1
         ENDIF
 10   CONTINUE

      CALL KZBCR1('CTTRACK',NWMCTR,CFMCTR,NCTTRK,LSECTR,CFSCTR, IERCTR)

c      print *,'ctanal;ntrctt,ncttrk = ',ntrctt,ncttrk
      NCTTRK = 0
      DO 100 ITR=1,NTRCTT

         CALL KZGET('MCCTHIT-TRACK',ITR,NDATA, IDATA)
         NHINF = IDATA(1)
         
c         print *,'ctanal;itr,nhinf = ',itr,nhinf
         IF (NHINF.GT.0) THEN

            NCTTRK = NCTTRK+1

            IRDMIN = 0
            NRPH = 0
            NRZ  = 0
            X0 = 0.
            Y0 = 0.
            Z0 = 0.
            NHTOT = 0
            DO 110 IHINF=1,NHINF
               CALL KZGETN('MCCTHIT-TRACK',
     &              ITR,IHINF,NDATA,IDATA)
               IHTNUM = IDATA(1)
               CALL KZGET('MCCTHITINF',IHTNUM,NDATA,IDATA)
               ITRAK = MOD(IDATA(1),1000)
c               print *,'ctanal;itrak = ',itrak
               IF (ITRAK.EQ.ITR) THEN
                  NHANO = IDATA(18)
                  NHBAS = IDATA(19)
c                  print *,'ctanal;nhano,nhbas = ',nhano,nhbas
                  IF (NHANO.GT.0) THEN
                     NHTOT = NHTOT+NHANO
                     DO 120 IHANO=1,NHANO
                        CALL KZGET('MCCTHIT',NHBAS+IHANO,NDATA,IDATA)
c                        print *,'ctanal;ihinf,ihano,itrak = ',
c     &                       ihinf,ihano,idata(1)
                        IADDR = IDATA(2)
                        ILAY  = IADDR/IALYCT
                        ICEL  = MOD(IADDR,IALYCT)/IAPHCT
                        IWIRE = MOD(IADDR,IAPHCT)/IAWRCT
                        IDET  = NANOCT*(ILAY-1)+IWIRE
                        TOF   = RDATA(7)
c                        print *,'ctanal;ilay,icel,iwire = ',
c     &                       ilay,icel,iwire
c                        print *,'tof = ',tof
                        IF (TOF.LT.TOFCUT) THEN
                           IF (IRDMIN.EQ.0 .OR. IDET.LT.IRDMIN) THEN
                              IRDMIN = IDET
                              X0 = RDATA(4)
                              Y0 = RDATA(5)
                              Z0 = RDATA(6)
                           ENDIF
                           IF(IAXSCT(ILAY).EQ.0) THEN
                              NRPH = NRPH+1
                              XRPH0(NRPH) = RDATA(4)
                              YRPH0(NRPH) = RDATA(5)
                              ZRPH0(NRPH) = RDATA(6)
                              SRPH0(NRPH) = SIGXY
                              TRPH0(NRPH) = TOF
c                              print *,'x,y,r = ',
c     &                             nrph,rdata(4),rdata(5),
c     &                             sqrt(rdata(4)**2+rdata(5)**2)
                           ELSE
                              NRZ = NRZ+1
                              XRZ0(NRZ) = RDATA(4)
                              YRZ0(NRZ) = RDATA(5)
                              ZRZ0(NRZ) = RDATA(6)
                              DRZ0(NRZ) = 
     &                             SIGXY/ABS(TAN(SANGCT(ILAY)*XDG2RD))
                              TRZ0(NRZ) = TOF
                           ENDIF
                        ENDIF
 120                 CONTINUE 
                  ENDIF
               ENDIF
 110        CONTINUE

            DO 130 I=8,22
               DDACTR(I) = 0.D0
 130        CONTINUE
            
c            print *,'ctanal;nrph,nrz = ',nrph,nrz
            
            IF (NRPH.GE.3) THEN
               
               CALL SORTFK(TRPH0,1,1,LSORT,NRPH)
               DO 140 I=1,NRPH
c                  print *,'i,tof = ',i,trph0(lsort(i))
                  XRPH(I) = XRPH0(LSORT(I))
                  YRPH(I) = YRPH0(LSORT(I))
                  ZRPH(I) = ZRPH0(LSORT(I))
                  SRPH(I) = SRPH0(LSORT(I))
c                  print *,'i,x,y,z,s = ',xrph(i),yrph(i),zrph(i),srph(i)
 140           CONTINUE 
            
               CALL SORTFK(TRZ0,1,1,LSORT,NRZ)
               DO 150 I=1,NRZ
c                  print *,'i,tof = ',i,trz0(lsort(i))
                  XRZ(I) = XRZ0(LSORT(I))
                  YRZ(I) = YRZ0(LSORT(I))
                  ZRZ(I) = ZRZ0(LSORT(I))
                  DRZ(I) = DRZ0(LSORT(I))
c                  print *,'i,x,y,z,d = ',xrz(i),yrz(i),zrz(i),drz(i)
 150           CONTINUE 
            
               CALL FTCIRC(NRPH,XRPH,YRPH,SRPH,
     &              SGNRPH,RADRPH,PH0RPH,RMNRPH,ERMRPH,RSIRPH,
     &              CHIRPH)

c            print *,'      ; rad(fit) = ',radrph
               
               PHIMIT = PH0RPH - 0.5*XPI*SGNRPH
               RDIST  = RADRPH - RMNRPH
               XCENT  = RDIST*COS(PHIMIT)
               YCENT  = RDIST*SIN(PHIMIT)
            
               IDACTR(13) = ITR
               RDACTR(1) = RMNRPH
               RDACTR(2) = PH0RPH
               IF (RADRPH.NE.0) THEN
                  RDACTR(3) = SGNRPH/RADRPH
               ELSE
                  RDACTR(3) = SGNRPH*1.0E+20
               ENDIF
               NFRRPH = NRPH-3
               IF (NFRRPH.GT.0) THEN
                  CHI=SQRT(CHIRPH/FLOAT(NFRRPH))
               ELSE
                  CHI = -1.
               ENDIF
               
               RDACTR( 4) = CHI
               IDACTR( 5) = NRPH
               
               DDACTR( 8) = ERMRPH(3,3)
               DDACTR( 9) = ERMRPH(2,3)
               DDACTR(10) = ERMRPH(2,2)
               
               DDACTR(11) = ERMRPH(1,3)
               DDACTR(12) = ERMRPH(1,2)

               DDACTR(13) = ERMRPH(1,1)

               IF (NRZ.GE.2) THEN

                  DO 160 I=1,NRZ
                     CALL CTSLEN(XCENT,YCENT,RADRPH,XRZ(I),YRZ(I),
     &                    0.,0., SL1,SL2)
                     SRZ(I) = SL1
                     IF (I.GT.1) THEN
                        IF (SL1.LT.SL0) THEN
                           SRZ(I) = SL2
                        ENDIF
                     ENDIF
                     SL0 = SRZ(I)
c                     print *,'s,z,r = ',i,srz(i),zrz(i),
c     &                    sqrt(xrz(i)**2+yrz(i)**2),trz0(lsort(i))
 160              CONTINUE
               
                  CALL FTLINE(NRZ, SRZ, ZRZ, DRZ,
     &                 ZMNRZ, DZSRZ, ERMRZ, RSIRZ, CHIRZ)
                  
                  RDACTR(6) = ZMNRZ
                  RDACTR(7) = DZSRZ
               
                  NFRRZ = NRZ-2
                  IF (NFRRZ.GT.0) THEN
                     CHI = SQRT(CHIRZ/FLOAT(NFRRZ))
                  ELSE
                     CHI = -1.
                  ENDIF

                  RDACTR(8) = CHI
                  IDACTR(9) = NRZ

                  DDACTR(17) = ERMRZ(1,1)
                  
                  DDACTR(21) = ERMRZ(1,2)
                  DDACTR(22) = ERMRZ(2,2)
                  
                  RDACTR(10) = X0
                  RDACTR(11) = Y0
                  RDACTR(12) = Z0

               ELSE

                  RDACTR(6) = 0.
                  RDACTR(7) = 0.
               
                  RDACTR(8) = 0.
                  IDACTR(9) = NRZ

                  DDACTR(17) = 0.D0

                  DDACTR(21) = 0.D0
                  DDACTR(22) = 0.D0
                  
                  RDACTR(10) = X0
                  RDACTR(11) = Y0
                  RDACTR(12) = Z0

               ENDIF

            ELSE
*-- Not enough r-phi hits found

               IDACTR(13) = ITR
               RDACTR(1) = 0.
               RDACTR(2) = 0.
               RDACTR(3) = 0.
               RDACTR(4) = 0.
               IDACTR(5) = NRPH
               
               DDACTR( 8) = 0.D0
               DDACTR( 9) = 0.D0
               DDACTR(10) = 0.D0
               
               DDACTR(11) = 0.D0
               DDACTR(12) = 0.D0
               DDACTR(14) = 0.D0
               
               RDACTR(6) = 0.
               RDACTR(7) = 0.
               RDACTR(8) = 0.
               IDACTR(9) = 0
               DDACTR(17) = 0.D0
               DDACTR(21) = 0.D0
               DDACTR(22) = 0.D0
               
               RDACTR(10) = 0.
               RDACTR(11) = 0.
               RDACTR(12) = 0.

            ENDIF
               
            CALL KZREP1('CTTRACK',NCTTRK,LSECTR,IDACTR)
            
c            print *,'ctanal;ncttrk = ',ncttrk
c            do j=1,14
c               print *,'ctanal;j,rdactr = ',j,rdactr(j)
c            enddo
c            do j=8,22
c               print *,'ctanal;j,ddactr = ',j,ddactr(j)
c            enddo
c            call ctpmom(ncttrk,pmom,icharg,iflag)
c            pp = pmom(4)
c            pt = sqrt(pmom(1)**2+pmom(2)**2)
c            costh = pmom(3)/pp
c            phi = 180./xpi*atan2(pmom(2),pmom(1))
c            print *,'i,p,pt,cos,phi(FIT) = ',
c     &           ncttrk,pp,pt,costh,phi,icharg
c            print *,' nrph,nrz        = ',nrph,nrz

c            call kzget('MCTRACK',ITR,NDATA,IDATA)
c            pp = sqrt(rdata(1)**2+rdata(2)**2+rdata(3)**2)
c            pt = sqrt(rdata(1)**2+rdata(2)**2)
c            costh = rdata(3)/pp
c            phi = 180./xpi*atan2(rdata(2),rdata(1))
c            print *,'i,p,pt,cos,phi(MC)  = ',
c     &           itr,pp,pt,costh,phi,idata(6)
c            print *,' '

         ENDIF

 100  CONTINUE

      IDATA(1) = NCTTRK
      CALL KZPUT1('CTTRACK',0,0,1,IDATA)

      RETURN
      END
