      SUBROUTINE CTSLEN( XC, YC, RC, XA, YA, XB, YB, TL1, TL2)
*.
*...CTSLEN   subroutine to calculate track length from A to B
*.
*.  INPUT    : XC     x coordinate of the center of the circle
*.           : YC     y coordinate
*.           : RC     radius of the circle
*.           : XA     x coordinate of hit point A
*.           : YA     y coordinate
*.           : XB     x coordiante of hit point B
*.           : YB     y coordinate
*.  OUTPUT   : TL1  length along the circle
*.
*. AUTHOR    : J. Kanzaki
*. VERSION   : 1.00
*. CREATED   : 07-Mar-1996
*. LAST MOD  : 07-Mar-1996
*.
*. HISTORY   :
*. 27-May-1985  CREATED BY  Yuji Nakagawa (TMU)
*. 06-Aug-1985  CHANGED BY  Yuji Nakagawa (TMU)
*. 17-Jan-1986   CHANGED BY  Takashi Oyama (TMU)

      IMPLICIT NONE
      REAL XC,YC,RC,XA,YA,XB,YB
      REAL TL1,TL2
      DOUBLE PRECISION  DXC,DYC,DRC,DXA,DYA,DXB,DYB,DPHIA,DPHIB,DPHI

      DOUBLE PRECISION PI
      PARAMETER (PI=3.14159265358979323846)

      
      IF (RC.EQ.0) THEN
         TL1 = 0.0
         TL2 = 0.0
         RETURN
      ENDIF   
      
      DXC = XC
      DYC = YC
      DRC = RC
      DXA = XA
      DYA = YA
      DXB = XB
      DYB = YB
      DPHIA = ATAN2( ( DYA-DYC ), ( DXA-DXC ) )
      DPHIB = ATAN2( ( DYB-DYC ), ( DXB-DXC ) )
      DPHI  = ABS( DPHIA - DPHIB )
      IF (DPHI.GE.PI) DPHI = 2.D0*PI - DPHI
      TL1 = DRC * DPHI
      TL2 = DRC *(2.D0*PI - DPHI)

      RETURN
      END
