      SUBROUTINE CTZCEL(Z,ILAY,IPHI,RAD0,RAD1,PHIC)
*.
*...CTZCEL   calculate maximum/minimum radius and central phi value
*.           of a super layer cell at a given point of z.
*.           this subroutine is used for stereo layers
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 06-Mar-1999
*.
*.**********************************************************************

      IMPLICIT NONE
      
#include "jlcnst.inc"
#include "ctgeo.inc"

      REAL Z
      INTEGER ILAY,IPHI

      REAL RAD0,RAD1
      REAL PHIC

      REAL ZMAX,D,RMIN,RMAX,PHI0,DPHI


      ZMAX = ZLLYCT(ILAY)

      D = 0.5*XYLYCT(ILAY)*Z/ZMAX
      
*--  minimum radius at z=0  
      RMIN = RILYCT(ILAY) - RLUNCT

*--  maximum radius at z=0  
      RMAX = (RILYCT(ILAY)+RLSCCT)*COS(STWICT(ILAY)*XDG2RD)

      PHI0 = FLOAT(IPHI-1)*X2PI/FLOAT(NPLYCT(ILAY))

      DPHI = SIGN(ATAN2(D,RMIN),Z*SANGCT(ILAY))
      
      PHIC = PHI0 + DPHI

      RAD0 = RMIN/COS(DPHI)
      RAD1 = RMAX/COS(DPHI)

      RETURN
      END
