*.    CTGEO
*.
*...CTGEO    Common for CT geometry
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 25-May-94
*. LAST MOD  : 29-Jul-94
*.
*. MODIFICATION LOG
*. 29-Jul-94 N.HOSODA Add SAVE statement
*. 28-Jun-94 N.Hosoda, Add CTVNAM
*.
*.**********************************************************************
      INTEGER NPSLCT,NPANCT
      PARAMETER (NPSLCT=25, NPANCT=5)
      REAL ROMACT,RIMACT,ZMACT,EPX1CT,EPY1CT
      INTEGER NSLYCT,NANOCT
      REAL PLSCCT,RLSCCT,RLUNCT,TCYLCT,TENPCT
      REAL RILYCT,ZLLYCT
      INTEGER NPLYCT,IAXSCT
      REAL SANGCT,STWICT,XYLYCT
      COMMON /CTGEO/ ROMACT,RIMACT,ZMACT,EPX1CT,EPY1CT,
     &     NSLYCT,NANOCT,PLSCCT,
     &     RLSCCT,RLUNCT,TCYLCT,TENPCT,
     &     RILYCT(NPSLCT),ZLLYCT(NPSLCT),
     &     NPLYCT(NPSLCT),IAXSCT(NPSLCT),
     &     SANGCT(NPSLCT),STWICT(NPSLCT),XYLYCT(NPSLCT)
      SAVE /CTGEO/
*.    ROMACT   230. ; outer radius of chamber gas volume
*.    RIMACT    45. ; inner radius of chamber gas volume
*.    ZMACT    230. ; half-z length of gas volume
*.    NSLYCT    25  ; number of super layers
*.    NANOCT     5  ; number of anode wires in one super layer
*.    TCYLCT   0.5  ; thickness of cylinder vessel
*.    TENPCT    5.  ; thickness of end-plate
*.    RLSCCT    7.  ; radial length of one super layer
*.    PLSCCT    5.  ; length of one super cell in phi-direction
*.    RLUNCT   1.4  ; sag of stereo wires at z=0
*.                  ; stereo angle of each stereo layer is determined
*.                  ; from this value.

*.    EPX1CT   213. ; end-plate z-length hyperbolic cosine parameters
*.    EPY1CT    70. ;                   "
*.
*.    Parameters for i-th layer
*.    RILYCT(i)     ; inner most radius
*.    ZLLYCT(i)     ; half z-length
*.    NPLYCT(i)     ; number of phi cells
*.    IAXSCT(i)     ; flag for axial/stereo
*.                  ;  = 0  for axial layers 
*.                  ;  = +/- 1 for stereo layers
*.                  ;    depending on signs of stereo angles
*.    SANGCT(i)     ; stereo angles
*.    STWICT(i)     ; twist angles
*.    XYLYCT(i)     ; wire length pojected on r-phi plane
*.
      INTEGER IALYCT, IAPHCT, IAWRCT
      PARAMETER (IALYCT=10000, IAPHCT=10, IAWRCT=1)
*.    Factors for wire addressing
*.         IADDR = IALYCT* ILAY + IAPHCT * IPHI + IAWRCT * IWIRE
*.         ILAY  = IADDR/ILAYCT
*.         IPHI  = MOD(IADDR,ILAYCT)/IAPHCT
*.         IWIRE = MOD(IADDR,IAPHCT)/IAWRCT
*.    IALYCT        ; for super layers
*.    IAPHCT        ; for phi cell divisions in a layer
*.    IAWRCT        ; for wire numbers in a cell
