C***********************************************************************
C*
C*(Contents)
C*    This common contains the various constants.
C*
C*  1) Single Precision Constants.
C*    XPI     =  ACOS(-1.0E0)
C*    X2PI    =  2 * XPI
C*    X4PI    =  4 * XPI
C*    XHPI    =  XPI / 2
C*    XRT2    =  SQRT(1.E0)
C*    XDG2RD  =  XPI/180. (Degree to Radian.)
C*    XRD2DG  =  180./XPI(Radian to Degree.)
C*    XCNSEC  =  Light Velocity (cm/nsec) (Ref. Particle Property Data
C*              Booklet, April, 1986)
C*
C*  2) Double Precision Constants.
C*    XPID    =  DACOS(-1.0D0)
C*    X2PID   =  2 * XPI
C*    X4PID   =  4 * XPI
C*    XHPID   =  XPI / 2
C*    XRT2D   =  DSQRT(1.D0)
C*
C* (Comments)
C*    All constants are calculated by REAL*16 variable, then converted
C*    to REAL*4 or REAL*8.
C*
C***********************************************************************

      REAL XPI
      PARAMETER (XPI   =3.141592653E0)
      DOUBLE PRECISION XPID
      PARAMETER (XPID  =3.141592653 589 793 238D0)

      REAL X2PI
      PARAMETER (X2PI  =6.283185307E0)
      DOUBLE PRECISION X2PID
      PARAMETER (X2PID =6.283185307 179 586 476D0)

      REAL X4PI
      PARAMETER (X4PI  =12.56637061E0)
      DOUBLE PRECISIOn X4PID
      PARAMETER (X4PID =12.56637061 435 917 295D0)

      REAL XHPI
      PARAMETER (XHPI  =1.570796326E0)
      DOUBLE PRECISION XHPID
      PARAMETER (XHPID =1.570796326 794 896 619D0)

      REAL XRT2
      PARAMETER (XRT2  =1.414213562E0)
      DOUBLE PRECISION XRT2D
      PARAMETER (XRT2D =1.414213562 373 095 048D0)

      REAL XDG2RD,XRD2DG
      PARAMETER (XDG2RD=1.745329251E-02)
      PARAMETER (XRD2DG=5.729577951E01)

      REAL XCNSEC
      PARAMETER (XCNSEC=2.99792458E01)

