      SUBROUTINE AMHITS
*.
*...AMHITS   Store HITS for the active mask
*.
*. INPUT     : non
*. OUTPUT    : non
*.
*. SEQUENCE  :
*. COMMON    : GCSETS GCKINE GCTRAK
*. CALLS     : GSCHIT
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J. Kanzaki
*. VERSION   : 1.00
*. CREATED   : 24-Jan-1999
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.   03-Mar-1999 Nakamura go to smearing mode even if destep=0
*.   25-Feb-1999 Nakamura add smearing mode
*.
*.**********************************************************************
*
*--   HITS(1): Particle code
*--   HITS(2): X position
*--   HITS(3): Y position
*--   HITS(4): X position
*--   HITS(5): Momentum of the particle
*--   HITS(6): Px of the particles
*--   HITS(7): Py of the particles
*--   HITS(8): Pz of the particles
*--   HITS(9): Deposited energy
      
      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcsets.inc"
#include "geant321/gckine.inc"
#include "geant321/gctrak.inc"
#include "geant321/gctmed.inc"
#include "geant321/gcvolu.inc"
#include "jmdet.inc"      
#include "amgeo.inc"
#include "amsmdt.inc"
#include "amhit.inc"

      INTEGER IHIT

      REAL HITS(NDHTAM)

*
*-- check skip flag
      IF (ISIMJD(IDETAM).EQ.ISKPJD) THEN 
*-- skip                   
         GOTO 999
      ELSE IF (ISIMJD(IDETAM).EQ.ISMRJD) THEN 
*-- smearing mode
         IF (NAMSMH.GE.MXHTAM) THEN
            WRITE(*,*) 'AM buffur full'
            GOTO 999
         ENDIF
         NAMSMH = NAMSMH + 1
         IAMSMH(1,NAMSMH) = IPART
         IAMSMH(2,NAMSMH) = ITRA
         RAMSMH(1,NAMSMH) = VECT(1)
         RAMSMH(2,NAMSMH) = VECT(2)
         RAMSMH(3,NAMSMH) = VECT(3)
         RAMSMH(4,NAMSMH) = VECT(7)
         RAMSMH(5,NAMSMH) = VECT(7)*VECT(4)
         RAMSMH(6,NAMSMH) = VECT(7)*VECT(5)
         RAMSMH(7,NAMSMH) = VECT(7)*VECT(6)
*-- terminate transport
         ISTOP = 1
      ELSE
*-- full simulation
*-- return unless energy loss
         IF (DESTEP.LE.0.) GOTO 999
*
         HITS(1)=IPART
         HITS(2)=VECT(1)
         HITS(3)=VECT(2)
         HITS(4)=VECT(3)
         HITS(5)=VECT(7)
         HITS(6)=VECT(7)*VECT(4)
         HITS(7)=VECT(7)*VECT(5)
         HITS(8)=VECT(7)*VECT(6)
*-- for GSCHIT, place hit-elements for accumulation in the last.
         HITS(9)=DESTEP*1.E6

*-- Stores element values for current hit into the data structure
         CALL GSCHIT(ISET,IDET,ITRA,NUMBV,HITS,1,IHIT)
      ENDIF
*
 999  CONTINUE
      
      RETURN
      END
