      SUBROUTINE BCFFRD
*.
*...BCFFRD   Read BC geometry data
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GEFILE BCGEO
*. CALLS     : FFSET  FFKEY  FFGO  
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 25-May-1994
*. LAST MOD  : 23-May-1995
*.
*. MODIFICATION LOG
*. 
*. 23-May-1995 Nakamura.I, Add BLOCK DATA 
*. 11-May-1995 Nakamura.I ,Replace DYALLC with JUALLC
*. 17-Jun-1994 Nakamura Isamu. Add BCSW DATA CARD
*. 21-Jun-1994 N.Hosoda, Add GETDID
*. 28-Jun-1994 N.Hosoda, Use not OPEN but DYALLC
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common for user
#include "jmdet.inc"
#include "bcgeo.inc"


      SWITBC(1) = 2
      SWITBC(2) = 0
      SWITBC(3) = 0
      SWITBC(4) = 0
      RINBC = 250.
      ZLBC = 800.
      ZIBC = 350.
      TSCEBC = 0.1
      TSCHBC = 0.2
      BLBC = 140.
      BSBC =  20.
      DEMBC = 20.
      TLGBC =  0.5
      PTLTBC = 3.
      NDPHBC = 64
      NDTHBC = 25

      IF (LUNMJD(IDETBC).LE.0) RETURN

*--   Set optional values
      CALL FFSET('LINP', LUNMJD(IDETBC))

*--   Define private data records
      CALL FFKEY('BCSW',SWITBC,4, 'INT ')
      CALL FFKEY('BRIN',RINBC ,1, 'REAL')
      CALL FFKEY('BZL ',ZLBC  ,1, 'REAL')
      CALL FFKEY('BZI ',ZIBC  ,1, 'REAL')
      CALL FFKEY('BTSE',TSCEBC,1, 'REAL')
      CALL FFKEY('BTSH',TSCHBC,1, 'REAL')
      CALL FFKEY('BBL ',BLBC  ,1, 'REAL')
      CALL FFKEY('BBS ',BSBC  ,1, 'REAL')
      CALL FFKEY('BDEM',DEMBC ,1, 'REAL')
      CALL FFKEY('BTLG',TLGBC ,1, 'REAL')
      CALL FFKEY('BTLT',PTLTBC,1, 'REAL')
      CALL FFKEY('BNPH',NDPHBC,1, 'INT ')
      CALL FFKEY('BNTH',NDTHBC,1, 'INT ')

*--   Read data cards
      CALL FFGO

  999 CONTINUE
      RETURN
      END
