      SUBROUTINE BCGEOM
*.
*...BCGEOM   Geomtry of the JLC barrel calorimeter.
*.           
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : BCGEO
*. CALLS     : BCSUB1 BCSUB2 BCSUB3
*. CALLED    : UGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 26-Apr-1994
*. LAST MOD  : 04-Feb-1999
*.
*. MODIFICATION LOG
*. 04-Feb-1999 : Koji ISHII
*.               setup for BIRK
*. 21-Apr-1995 : Nakamura Isamu
*.               BCSUB3 is disabled.
*. 13-Jun-1994 : Nakamura Isamu
*.               Geometry Type Switch is Introduced.
*.               It Calls One of BCSUB? Subroutines.
*.
*.**********************************************************************
*
*. Parameters ( User Define )
*.
*.     RINBC   : BCAL inner radius
*.     ZLBC    : BCAL Z length
*.     ZIBC    : Half Z length you want to cover.
*.     NDTHBC  : # of division in THETA direction
*.     NDPHBC  : # of division in PHI direction
*.     TSCEBC  : Tickness of Scintillator (EM)
*.     TSCHBC  : Tickness of Scintillator (HAD)
*.     BLBC    : BC Tower Block Length
*.     DEMBC   : Depth of EM part
*.     TLGBC   : Tickness of WLS plate.
*.     PTLTBC  : Telt Angle in phi
*.**********************************************************************
      IMPLICIT NONE
*
C
C Include GEANT include file
C
#include "geant321/gcflag.inc"
#include "jmmat.inc"
#include "jmmed.inc"
#include "jmdet.inc"
#include "bcgeo.inc"
#include "bcmed.inc"

      IF (ISIMJD(IDETCT).EQ.ISKPJD) RETURN

      ILEDBC = NMEDJM*IDETBC+1
      CALL GSTMED(ILEDBC, 'LEAD', IMLEAD, ISENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)
      
      ISCIBC = NMEDJM*IDETBC+2
      CALL GSTMED(ISCIBC, 'SCINTI', IMSCIN, ISENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)

CKI set for BIRK
      CALL GSTPAR(ISCIBC,'BIRK1',1.)
      CALL GSTPAR(ISCIBC,'BIRK2',0.013)
      CALL GSTPAR(ISCIBC,'BIRK3',9.6E-6)
CKI end

C
C Fundamental Constants.
C
C      RINBC     = 250.
C      ZLBC      = 800.
C      ZIBC      = 300.
C      TSCEBC    = 1.  
C      TSCHBC    = 2.  
C      BLBC      = 140.
C      BSBC      = 10.
C      DEMBC     = 20. 
C      NDTHBC    = 25     
C      TLGBC     = 1.
C      PTLTBC    = 3.

C      WRITE(*,*) RINBC,ZLBC,ZIBC,TSCEBC,TSCHBC,BLBC
C      WRITE(*,*) BSBC,DEMBC,NDTHBC,TLGBC,PTLTBC

      IF (SWITBC(1).EQ.1) THEN
         CALL BCSUB1
      ELSEIF (SWITBC(1).EQ.2) THEN 
         CALL BCSUB2
C      ELSEIF (SWITBC(1).EQ.3) THEN 
C         CALL BCSUB3
      ELSE
         CALL BCSUB1
      ENDIF
C
C   Print SET and DETector parameters
C
C      IF (ISWIT(3) .GE. 1) CALL GPSETS('BC  ','*   ')
C       CALL GPSETS('BC  ','*   ')
C
      RETURN
      END
