      SUBROUTINE BCHITS
*.
*...BCHITS   Store HITS for the barrel calorimeter
*.
*. INPUT     : non
*. OUTPUT    : non
*.
*. SEQUENCE  :
*. COMMON    : UHTOC GLVOLU GDTOM GSCHIT
*. CALLS     : 
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 17-May-1994
*. LAST MOD  : 10-Feb-1998
*.
*. MODIFICATION LOG
*.  10-Feb-1998 : K.Ishii
*.              Modification and clean up
*.  06-Nov-1998 : J.Kanzaki
*.            : There is no need to call GLVOLU.  Just change NLEVEL.
*.  27-Mar-1996 : K.Ishii
*.              remove HITS(6)
*.  06-Mar-1996 : K.Ishii
*.              Added GLVOLU at the end
*.  21-Apr-1995 : Nakamura Isamu
*.              Ecal is divided into 4 sub section.
*.              Hcal hit is divided for two PMT
*.              Time of Flight Information is added.
*.
*.**********************************************************************
      IMPLICIT NONE

#include "geant321/gcsets.inc"
#include "geant321/gctrak.inc"
#include "geant321/gckine.inc"
#include "geant321/gcvolu.inc"
#include "geant321/gctmed.inc"
      
#include "pdparm.inc"
#include "jmdet.inc"
#include "bcgeo.inc"

      CHARACTER*2 CDET

      REAL TOFCUT
      PARAMETER (TOFCUT = 1.0E-7)

      IF (TOFG.GT.TOFCUT) THEN
         ISTOP = 4
         RETURN 
      ENDIF

*-- Get Detector Name ( BE (BH) means Barrel EM (HAD))
      CALL UHTOC(NAMES(6),4,CDET,2)

*-- Simulate BC in smearing mode
      IF (ISIMJD(IDETBC).EQ.ISMRJD) THEN
         CALL BCHTSM
      ENDIF
*     
*-- store hits
*   (Whichever the mode is SMEAR or FULL, 
*    energy deposite of this step should be stored.)
* 
      CALL BCHTFL(CDET)

      RETURN
      END
