      SUBROUTINE BCHTFL(CDET)
*.
*...BCHTSM   BC Hit routine with FuLl mode
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 
*. LAST MOD  : 09-Feb-1999
*.
*. MODIFICATION LOG
*. 03-Mar-1999 : K.Ishii ; Added 20 ns TOF cut 
*. 09-Feb-1999 : K.Ishii ; Drop EM cutoff for secondary tracks. 
*. 06-Feb-1999 : Koji ISHII
*.               bug fixed (LOR initialisation)
*.
*.**********************************************************************
      IMPLICIT NONE

*-- include files
#include "geant321/gckmax.inc"
#include "geant321/gcsets.inc"
#include "geant321/gctrak.inc"
#include "geant321/gcking.inc"
#include "geant321/gckine.inc"
#include "geant321/gccuts.inc"
#include "geant321/gcvolu.inc"
#include "pdparm.inc"
#include "bcgeo.inc"
#include "bchit.inc"

*-- input argement
      CHARACTER*2 CDET

      REAL TOFCUT
      PARAMETER (TOFCUT = 2.0E-8)
      
*--   
      INTEGER I
      INTEGER IHIT,IPHI0,ITHET0
      REAL XMAST(3),XLOCA(3),BHSIZ(4)
      REAL HITS(NDHTBC),LOR(4),EDEP

      INTEGER NHSUM
      PARAMETER (NHSUM=4)

*-- return if no energy deposition
      IF (DESTEP.LE.0.) RETURN 

*-- return if track TOF is more than 20 ns
      IF (TOFG.GT.TOFCUT) RETURN 

CKI Initialize Position related value
      DO 310 I=1,4
         LOR(I) = 0.
 310  CONTINUE
CKI

*-- get calorimeter segment number
      IPHI0  = NUMBER(3)
      ITHET0 = NUMBER(5)

*-- get position in MASTER volume
      XMAST(1) = VECT(1)
      XMAST(2) = VECT(2)
      XMAST(3) = VECT(3)

*-- convert to calorimeter local coordinate
      NLEVEL = 5
      CALL GMTOD(XMAST,XLOCA,1)

*-- case 'BE'
*-- Barrel EM cal
      IF (CDET.EQ.'BE') THEN

*-- Get segment ID (Ecal is divided in 4 subsegment)
         IF (XLOCA(1).LE.0) THEN
            IF (XLOCA(2).LE.0) THEN
               LOR(1) = 1.
            ELSE
               LOR(2) = 1.
            ENDIF
         ELSE
            IF (XLOCA(2).LE.0) THEN
               LOR(3) = 1.
            ELSE
               LOR(4) = 1.
            ENDIF
         ENDIF

*-- case 'BH'
*-- Barrel HAD cal
      ELSE IF (CDET.EQ.'BH') THEN

*-- weighted mean (this type is obsolete may reviced)
         BHSIZ(1) = SIZBC(1,ITHET0)
     &        +(SIZBC(4,ITHET0)-SIZBC(1,ITHET0))
     &        *(SIZBC(7,ITHET0)+XLOCA(3))/SIZBC(7,ITHET0)/2.
         BHSIZ(2) = SIZBC(2,ITHET0)
     &        +(SIZBC(5,ITHET0)-SIZBC(2,ITHET0))
     &        *(SIZBC(7,ITHET0)+XLOCA(3))/SIZBC(7,ITHET0)/2.
         BHSIZ(3) = SIZBC(3,ITHET0)
     &        +(SIZBC(6,ITHET0)-SIZBC(3,ITHET0))
     &        *(SIZBC(7,ITHET0)+XLOCA(3))/SIZBC(7,ITHET0)/2.
         BHSIZ(4)= BHSIZ(2)+(BHSIZ(3)-BHSIZ(2))
     &        *(BHSIZ(1)+XLOCA(2))/BHSIZ(1)/2.
         LOR(1) = 0.5-XLOCA(1)/BHSIZ(4)/2.
         LOR(2) = 0.5+XLOCA(1)/BHSIZ(4)/2.
         DO 20 I=1,2
            IF (LOR(I).LT.0.) LOR(I)=0.
            IF (LOR(I).GT.1.) LOR(I)=1.
 20      CONTINUE
      ENDIF

*-- Birk Correction
      CALL GBIRK(EDEP)

*-- Store HIT Information into Bank JHITS.
      HITS(1) = TOFG
      HITS(2) = EDEP*LOR(1)
      HITS(3) = EDEP*LOR(2)
      HITS(4) = EDEP*LOR(3)
      HITS(5) = EDEP*LOR(4)
      CALL GSCHIT(ISET,IDET,ITRA,NUMBV,HITS,NHSUM,IHIT)

*--
      NLEVEL = 6

      RETURN 
      END
