      SUBROUTINE BCHTSM
*.
*...BCHTSM   BC Hit routine with SMearing mode
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 05-Mar-1999 : K.Ishii  Changed EM condition (FLAG)
*. 03-Mar-1999 : K.Ishii  
*.               Protect ZERO momentum case (secandary)
*. 02-Mar-1999 : K.Ishii 
*.               Buffer extended for overlap region
*. 17-Feb-1999 : Koji ISHII
*.               Clean up and debug
*. 14-Feb-1999 : Koji ISHII
*.               Added NLEVEL save 
*. 09-Feb-1999 : Koji ISHII
*.               Modification(CALL SMFALL directly etc.)
*.
*.**********************************************************************
      IMPLICIT NONE

*-- include files
#include "geant321/gckmax.inc"
#include "geant321/gctrak.inc"
#include "geant321/gckine.inc"
#include "geant321/gcsets.inc"
#include "geant321/gcking.inc"
#include "geant321/gcvolu.inc"
#include "pdparm.inc"
#include "bcgeo.inc"
#include "bchit.inc"
#include "bcsmdt.inc"

*--
      INTEGER I,J,K,IT,IP

      REAL PPOS(3),PMOM(3)
      INTEGER NX,NY,NZ
      PARAMETER (NX=16,NY=16,NZ=3)
      REAL EDEPO(NX,NY,NZ)
      REAL VWORK1(NX,NY,NZ),VWORK2(NX,NY,NZ)
      REAL CUT1ST,CUT2ND
      PARAMETER (CUT1ST=100.0,CUT2ND=100.0)
      INTEGER ILEVEL,IPRT,IPHI0,ITHET0
      INTEGER NLSAVE
      REAL EKIN,PTOT

      INTEGER FLAG
      REAL SCMASS
      
*-- Detector COPY number where we are
      IPHI0  = NUMBER(3)
      ITHET0 = NUMBER(4)

CKI
*-- EM cut is CUT1ST and Muon is NOCUT
CC      IF ((IPART.LE.3.AND.GEKIN.LE.CUT1ST).OR.
CC     &   (IPART.EQ.5).OR.(IPART.EQ.6)) THEN
      IF (IPART.LE.3.AND.GEKIN.LE.CUT1ST) THEN

*-- get current position in the sub-detector system
         NLSAVE = NLEVEL
         NLEVEL = 4
         CALL GMTOD(VECT(1),PPOS(1),1)
         PPOS(3) = PPOS(3) + BLBC/2.

*-- get momentum in  the sub-detector system
         CALL GMTOD(VECT(4),PMOM(1),2)
         NLEVEL = NLSAVE

CKI
*   FLAG EM MODE   
*-- 0: for surface injection (shape generate also in radial direction)
*-- 1: for secondary inside volume (shape just in depth (momentum) direction)
         FLAG = 0
         IF(GEKIN.LE.0.5) FLAG = 1

CKI
*-- invoke smearing function
         CALL SMFALL(IPART,AMASS,GEKIN,PMOM,PPOS,FLAG,
     &     NX,NY,NZ,EDEPO,VWORK1,VWORK2)

*-- Store HIT Information into Bank JHITS.
*-- ECAL 
*-- run over theta direction (Y in sub-detector coorinate)
         DO 100 I=1,16
*-- detector numbr in JIM
            IT = 2*ITHET0+I-9
*-- check out of bounds
CKI            IF (IT.LE.0.OR.IT.GT.2*NDTHBC) GOTO 100
            IF(IT.GT.-10.AND.IT.LE.0) THEN
               IT = NMXBET - 20 + ABS(IT-1)
            ELSEIF(IT.GT.2*NDTHBC.AND.IT.LE.2*NDTHBC+10) THEN
               IT = NMXBET - 10 + IT - 2*NDTHBC
            ELSEIF (IT.LE.-10.OR.IT.GT.2*NDTHBC+10) THEN
               GOTO 100
            ENDIF
*-- run over phi direction (X in sub-detector coorinate)
            DO 110 J=1,16
*-- detector numbr in JIM
               IP = 2*IPHI0+J-9+2*NDPHBC
               IP = MOD(IP,2*NDPHBC)
               IF (IP.EQ.0) IP=2*NDPHBC
*-- add presampler hits
               IF (EDEPO(J,I,1).GT.0.) 
     &              EBCSMP(IT,IP) = EBCSMP(IT,IP) + EDEPO(J,I,1)
*-- add ECAL hits
               IF (EDEPO(J,I,2).GT.0.) 
     &              EBCSME(IT,IP) = EBCSME(IT,IP) + EDEPO(J,I,2)
 110        CONTINUE 
 100     CONTINUE 
*-- HCAL 
*-- run over theta direction (Y in sub-detector coorinate)
         DO 200 I=1,16
*-- detector number in JIM
            IT = ITHET0 + NINT((I-.5)/2.)-4
*-- check out of bounds
CKI            IF (IT.LE.0.OR.IT.GT.NDTHBC) GOTO 200
            IF(IT.GT.-5.AND.IT.LE.0) THEN
               IT = NMXBHT - 10 + ABS(IT-1)
            ELSEIF(IT.GT.NDTHBC.AND.IT.LE.NDTHBC+5) THEN
               IT = NMXBHT - 5 + IT - NDTHBC
            ELSEIF (IT.LE.-5.OR.IT.GT.NDTHBC+5) THEN
               GOTO 200
            ENDIF
*-- run over phi direction (X in sub-detector coorinate)
            DO 210 J=1,16
*-- detector numbr in JIM
               IP = IPHI0 + NINT((J-.5)/2.)-4 + NDPHBC
               IP = MOD(IP,NDPHBC)
               IF (IP.EQ.0) IP=NDPHBC
*-- add HCAL hits
               IF (EDEPO(J,I,3).GT.0.) 
     &              EBCSMH(IT,IP) = EBCSMH(IT,IP) + EDEPO(J,I,3)
 210        CONTINUE 
 200     CONTINUE 

*-- terminate transport
         ISTOP=4
      ENDIF
      
C------------------------
*-- for secondaries
C------------------------
      DO 10 I=1,NGKINE

CSY *******************************************************
CSY Neutrino Discard
         IF(AINT(GKIN(5,I)).eq.4) THEN
            IFLGK(I) = -1    ! discard
            GOTO 10
         ENDIF
CSY *******************************************************

*-- get current position in the sub-detector system
         NLSAVE = NLEVEL
         NLEVEL = 4
         CALL GMTOD(GPOS(1,I),PPOS(1),1)
         PPOS(3) = PPOS(3) + BLBC/2.

*-- get momentum in  the sub-detector system
         CALL GMTOD(GKIN(1,I),PMOM(1),2)
         NLEVEL = NLSAVE
         IPRT = GKIN(5,I)
CKI
*-- pi0 skip
         IF (IPRT.EQ.7) GOTO 10
*-- Alpha skip
         IF (IPRT.EQ.47) GOTO 10

*-- ZERO momentum (<1.0 KeV) treatment
         PTOT=SQRT(PMOM(1)**2+PMOM(2)**2+PMOM(3)**2)
         IF (PTOT.LE.0.000001) THEN
            IF(IPRT.LE.3) IFLGK(I) = -1
            GOTO 10
         ENDIF

CKI
*-- get mass and kinetic energy
         CALL SMMASS(IPRT,SCMASS)
         EKIN = GKIN(4,I) - SCMASS

*-- ZERO K.E. (<1.0 KeV) treatment
         IF (EKIN.LE.0.000001) THEN
            IF(IPRT.LE.3) IFLGK(I) = -1
            GOTO 10
         ENDIF

CKI
*   FLAG EM MODE   
*-- 0: for surface injection (shape generate also in radial direction)
*-- 1: for secondary inside volume (shape just in depth (momentum) direction)
         FLAG = 0

CKI
*-- Cut is applied with CTU2ND
         IF (EKIN.LE.CUT2ND) THEN

CKI
*-- invoke smearing function
            CALL SMFALL(IPRT,SCMASS,EKIN,PMOM,PPOS,FLAG,
     &        NX,NY,NZ,EDEPO,VWORK1,VWORK2)

*-- Store HIT Information into Bank JHITS.
*-- ECAL 
*-- run over theta direction (Y in sub-detector coorinate)
            DO 300 K=1,16
*-- detector numbr in JIM
               IT = 2*ITHET0+K-9
*-- check out of bounds
CKI               IF (IT.LE.0.OR.IT.GT.2*NDTHBC) GOTO 300
               IF(IT.GT.-10.AND.IT.LE.0) THEN
                  IT = NMXBET - 20 + ABS(IT-1)
               ELSEIF(IT.GT.2*NDTHBC.AND.IT.LE.2*NDTHBC+10) THEN
                  IT = NMXBET - 10 + IT - 2*NDTHBC
               ELSEIF (IT.LE.-10.OR.IT.GT.2*NDTHBC+10) THEN
                  GOTO 300
               ENDIF
*-- run over phi direction (X in sub-detector coorinate)
               DO 310 J=1,16
*-- detector numbr in JIM
                  IP = 2*IPHI0+J-9+2*NDPHBC
                  IP = MOD(IP,2*NDPHBC)
                  IF (IP.EQ.0) IP=2*NDPHBC
*-- check out of bounds
                  IF (IP.LE.0.OR.IP.GT.2*NDPHBC) GOTO 310
*-- add presampler hits
                  IF (EDEPO(J,K,1).GT.0.) 
     &              EBCSMP(IT,IP) = EBCSMP(IT,IP) + EDEPO(J,K,1)
*-- add ECAL hits
                  IF (EDEPO(J,K,2).GT.0.) 
     &              EBCSME(IT,IP) = EBCSME(IT,IP) + EDEPO(J,K,2)
 310           CONTINUE 
 300        CONTINUE 
*-- HCAL 
*-- run over theta direction (Y in sub-detector coorinate)
            DO 400 K=1,16
*-- detector numbr in JIM
               IT = ITHET0 + NINT((K-.5)/2.)-4
*-- check out of bounds
CKI               IF (IT.LE.0.OR.IT.GT.NDTHBC) GOTO 400
               IF(IT.GT.-5.AND.IT.LE.0) THEN
                  IT = NMXBHT - 10 + ABS(IT-1)
               ELSEIF(IT.GT.NDTHBC.AND.IT.LE.NDTHBC+5) THEN
                  IT = NMXBHT - 5 + IT - NDTHBC
               ELSEIF (IT.LE.-5.OR.IT.GT.NDTHBC+5) THEN
                  GOTO 400
               ENDIF
*-- run over phi direction (X in sub-detector coorinate)
               DO 410 J=1,16
*-- detector numbr in JIM
                  IP = IPHI0 + NINT((J-.5)/2.)-4 + NDPHBC
                  IP = MOD(IP,NDPHBC)
                  IF (IP.EQ.0) IP=NDPHBC
*-- add HCAL hits
                  IF (EDEPO(J,K,3).GT.0.) 
     &              EBCSMH(IT,IP) = EBCSMH(IT,IP) + EDEPO(J,K,3)
 410           CONTINUE 
 400        CONTINUE 

*-- terminate transport
            IFLGK(I) = -1
         ENDIF
 10   CONTINUE 

*-- 
 999  CONTINUE 

      RETURN
      END
