      SUBROUTINE CTFFRD
*.
*...CTFFRD   Read CT geometry data
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GEFILE CTGEO
*. CALLS     : FFSET  FFKEY  FFGO
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 25-May-1994
*. LAST MOD  : 11-May-1995
*.
*. MODIFICATION LOG
*. 11-May-1995 Nakamura.I ,Replace DYALLC with JUALLC
*. 27-May-1994 N.Hosoda, Add find data file name part
*. 15-JUN-1994 N.Hosoda, Use GETDID
*. 18-JUN-1994 N.Hosoda, Set FFKEY
*. 28-Jun-1994 N.Hosoda, Use not OPEN but DYALLC
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common for user
#include "jmdet.inc"
#include "ctgeo.inc"
#include "ctsim.inc"

*-- CDC geometry parameter
*--    outer radius
      ROMACT = 230.
*--    inner radius
      RIMACT = 45.
*--    z-half length
      ZMACT  = 230.
      EPX1CT = 213.
      EPY1CT =  70.
*--    # super layers
      NSLYCT = 25
*--    # wiers in a layer
      NANOCT = 5
      PLSCCT = 5.
      RLSCCT = 7.
      RLUNCT = 1.4
      TCYLCT = 0.5
      TENPCT = 5.0

      NAHTCT = 1
      IBNKCT = ISBKCT

      IF (LUNMJD(IDETCT).LE.0) RETURN

*--   Set optional values
      CALL FFSET('LINP', LUNMJD(IDETCT))

*--   Define private data records
      CALL FFKEY('ROMA', ROMACT, 1, 'REAL')
      CALL FFKEY('RIMA', RIMACT, 1, 'REAL')
      CALL FFKEY('ZMAS', ZMACT , 1, 'REAL')
      CALL FFKEY('EPX1', EPX1CT, 1, 'REAL')
      CALL FFKEY('EPY1', EPY1CT, 1, 'REAL')
      CALL FFKEY('NSLY', NSLYCT, 1, 'INTEGER')
      CALL FFKEY('NANO', NANOCT, 1, 'INTEGER')
      CALL FFKEY('PLSC', PLSCCT, 1, 'REAL')
      CALL FFKEY('RLSC', RLSCCT, 1, 'REAL')
      CALL FFKEY('RLUN', RLUNCT, 1, 'REAL')
      CALL FFKEY('TCYL', TCYLCT, 1, 'REAL')
      CALL FFKEY('TENP', TENPCT, 1, 'REAL')

      CALL FFKEY('NAHT', NAHTCT, 1, 'INTEGER')
      CALL FFKEY('BSIZ', IBNKCT, 1, 'INTEGER')

*--   Read data cards
      CALL FFGO

  999 CONTINUE
      RETURN
      END
