      SUBROUTINE ECHITS
*.
*...ECHITS   Store HITS for the endcap calorimeter
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 17-May-1994
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 09-Feb-1999 : K.Ishii
*.               Add BIRK correction
*. 06-Mar-1996 : K.Ishii
*.               Modified the calculation of size parameters
*.
*.**********************************************************************
      IMPLICIT NONE

#include "geant321/gcsets.inc"
#include "geant321/gctrak.inc"
#include "geant321/gckine.inc"
#include "geant321/gcvolu.inc"
#include "geant321/gctmed.inc"
#include "geant321/gconst.inc"

#include "pdparm.inc"
#include "jmdet.inc"
#include "ecgeo.inc"
#include "echit.inc"

      CHARACTER*2 CDET

      REAL TOFCUT
      PARAMETER (TOFCUT = 1.0E-7)

      IF (TOFG.GT.TOFCUT) THEN
         ISTOP = 4
         RETURN 
      ENDIF

*-- Get Detector Name ( EE (EH) means Endcap EM (HAD))
      CALL UHTOC(NAMES(5),2,CDET,2)

*-- Simulate EC in smearing mode
      IF (ISIMJD(IDETEC).EQ.ISMRJD) THEN
         CALL ECHTSM
      ENDIF
*     
*-- store hits
*   (Whichever the mode is SMEAR or FULL, 
*    energy deposite of this step should be stored.)
* 
      CALL ECHTFL(CDET)

      RETURN
      END
