      SUBROUTINE ECHTSM
*.
*...BCHTSM   EC Hit routine with SMearing mode
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Koji ISHII
*. VERSION   : 1.01
*. CREATED   : 18-Feb-1999
*. LAST MOD  :
*.
*. MODIFICATION LOG
*.    05-Mar-1999  K.Ishii  Changed EM condition (FLAG)
*.    03-Mar-1999  K.Ishii  Protect ZERO momentum case (secandary)
*.    02-Mar-1999  K.Ishii  Buffer extended for overlap region 
*.
*.**********************************************************************
      IMPLICIT NONE

*-- include files
#include "geant321/gckmax.inc"
#include "geant321/gctrak.inc"
#include "geant321/gckine.inc"
#include "geant321/gcsets.inc"
#include "geant321/gcking.inc"
#include "geant321/gcvolu.inc"
#include "pdparm.inc"
#include "ecgeo.inc"
#include "echit.inc"
#include "ecsmdt.inc"

*--
      INTEGER I,J,K,IP,JR

      REAL PPOS(3),PMOM(3)
      INTEGER NX,NY,NZ
CKI      PARAMETER (NX=128,NY=18,NZ=3)
      PARAMETER (NX=128,NY=22,NZ=3)
      REAL EDEPO(NX,NY,NZ)
      REAL VWORK1(NX,NY,NZ),VWORK2(NX,NY,NZ)
      REAL CUT1ST,CUT2ND
      PARAMETER (CUT1ST=100.0,CUT2ND=100.0)
      INTEGER ILEVEL,IPRT,IRRR0,IPHI0,IFORB
      INTEGER NLSAVE
      REAL EKIN,PTOT

      INTEGER FLAG
      REAL SCMASS
      
*-- Detector COPY number where we are
      IFORB = NUMBER(2)
      IRRR0 = NUMBER(3)
      IPHI0 = NUMBER(4)

CKI
*-- EM cut is CUT1ST and Muon is NOCUT
CC      IF ((IPART.LE.3.AND.GEKIN.LE.CUT1ST).OR.
CC     &   (IPART.EQ.5).OR.(IPART.EQ.6)) THEN
      IF (IPART.LE.3.AND.GEKIN.LE.CUT1ST) THEN

*-- get current position in the sub-detector system
         NLSAVE = NLEVEL
         NLEVEL = 3
         CALL GMTOD(VECT(1),PPOS(1),1)
         PPOS(3) = PPOS(3) + BLEC/2.

*-- get momentum in  the sub-detector system
         CALL GMTOD(VECT(4),PMOM(1),2)
         NLEVEL = NLSAVE

CKI
*   FLAG EM MODE   
*-- 0: for surface injection (shape generate also in radial direction)
*-- 1: for secondary inside volume (shape just in depth (momentum) direction)
         FLAG = 0
         IF(GEKIN.LE.0.5) FLAG = 1

CKI
*-- invoke smearing function
         CALL SMFALL(IPART,AMASS,GEKIN,PMOM,PPOS,FLAG,
     &     NX,NY,NZ,EDEPO,VWORK1,VWORK2)

*-- Store HIT Information into Bank JHITS.
*-- ECAL 
*-- run over Phi direction 
         DO 100 I=1,NX
*-- run over R direction 
            DO 110 J=1,NY
*-- add presampler hits
               IF (EDEPO(I,J,1).GT.0.) 
     &              EECSMP(I,J,IFORB) = EECSMP(I,J,IFORB)
     &                                  + EDEPO(I,J,1)
*-- add ECAL hits
               IF (EDEPO(I,J,2).GT.0.) 
     &              EECSME(I,J,IFORB) = EECSME(I,J,IFORB)
     &                                  + EDEPO(I,J,2)
 110        CONTINUE 
 100     CONTINUE 

*-- HCAL 
*-- run over Phi direction 
         DO 200 I=1,NX
            IP = NINT((I+.5)/2.)
*-- run over R direction 
            DO 210 J=1,NY
               JR = NINT((J+.5)/2.)
*-- add HCAL hits
               IF (EDEPO(I,J,3).GT.0.) 
     &              EECSMH(IP,JR,IFORB) = EECSMH(IP,JR,IFORB)
     &                                    + EDEPO(I,J,3)
 210        CONTINUE 
 200     CONTINUE 

*-- terminate transport
         ISTOP=4
      ENDIF
      
C------------------------
*-- for secondaries
C------------------------
      DO 10 I=1,NGKINE

CSY *******************************************************
CSY Neutrino Discard
        IF(AINT(GKIN(5,I)).eq.4) THEN
           IFLGK(I) = -1    ! discard
           GOTO 10
        ENDIF
CSY *******************************************************

*-- get current position in the sub-detector system
         NLSAVE = NLEVEL
         NLEVEL = 3
         CALL GMTOD(GPOS(1,I),PPOS(1),1)
         PPOS(3) = PPOS(3) + BLEC/2.

*-- get momentum in  the sub-detector system
         CALL GMTOD(GKIN(1,I),PMOM(1),2)
         NLEVEL = NLSAVE
         IPRT = GKIN(5,I)
CKI
*-- pi0 skip
         IF (IPRT.EQ.7) GOTO 10
*-- Alpha skip
         IF (IPRT.EQ.47) GOTO 10

*-- ZERO momentum (<1.0 KeV) treatment
         PTOT=SQRT(PMOM(1)**2+PMOM(2)**2+PMOM(3)**2)
         IF (PTOT.LE.0.000001) THEN
            IF(IPRT.LE.3) IFLGK(I) = -1
            GOTO 10
         ENDIF

CKI
*-- get mass and kinetic energy
         CALL SMMASS(IPRT,SCMASS)
         EKIN = GKIN(4,I) - SCMASS

*-- ZERO K.E. (<1.0 KeV) treatment
         IF (EKIN.LE.0.000001) THEN
            IF(IPRT.LE.3) IFLGK(I) = -1
            GOTO 10
         ENDIF

CKI
*   FLAG EM MODE   
*-- 0: for surface injection (shape generate also in radial direction)
*-- 1: for secondary inside volume (shape just in depth (momentum) direction)
         FLAG = 0

CKI
*-- Cut is applied with CTU2ND
         IF (EKIN.LE.CUT2ND) THEN

CKI
*-- invoke smearing function
            CALL SMFALL(IPRT,SCMASS,EKIN,PMOM,PPOS,FLAG,
     &        NX,NY,NZ,EDEPO,VWORK1,VWORK2)

*-- Store HIT Information into Bank JHITS.
*-- ECAL 
*-- run over Phi direction 
            DO 300 K=1,NX
*-- run over R direction 
               DO 310 J=1,NY
*-- add presampler hits
                  IF (EDEPO(K,J,1).GT.0.) 
     &              EECSMP(K,J,IFORB) = EECSMP(K,J,IFORB)
     &                                  + EDEPO(K,J,1)
*-- add ECAL hits
                  IF (EDEPO(K,J,2).GT.0.) 
     &              EECSME(K,J,IFORB) = EECSME(K,J,IFORB)
     &                                  + EDEPO(K,J,2)
 310           CONTINUE 
 300        CONTINUE 

*-- HCAL 
*-- run over Phi direction 
            DO 400 K=1,NX
               IP = NINT((K+.5)/2.)
*-- run over R direction 
               DO 410 J=1,NY
                  JR = NINT((J+.5)/2.)
*-- add HCAL hits
                  IF (EDEPO(K,J,3).GT.0.) 
     &              EECSMH(IP,JR,IFORB) = EECSMH(IP,JR,IFORB)
     &                                    + EDEPO(K,J,3)
 410           CONTINUE 
 400        CONTINUE 

*-- terminate transport
            IFLGK(I) = -1
         ENDIF
 10   CONTINUE 

*-- 
 999  CONTINUE 

      RETURN
      END
