      SUBROUTINE ECSPAR
*.
*...ECSPAR   Saves Endcap Calorimeter Parameters into ZBS Bank.
*.           
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : JMSAVP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 3-AUG-1994
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

#include "ecgeo.inc"

      INTEGER NSEGM
      PARAMETER (NSEGM = 12)
      INTEGER IDATA(NSEGM)
      REAL    RDATA(NSEGM)
      EQUIVALENCE (RDATA(1),IDATA(1))

      INTEGER IER,I

*-- Create ZBS Bank MCECPAR
      CALL KZBCR1('MCECPAR',NSEGM,'2I 10F',NDREC,1,'1I',IER)

*-- Store Data to given Segment of Bank MCECPAR
      IDATA(1)  = SWITEC
      IDATA(2)  = NDREC
      RDATA(3)  = RI1EC
      RDATA(4)  = RO1EC
      RDATA(5)  = RI2EC
      RDATA(6)  = RO2EC 
      RDATA(7)  = ZIEC
      RDATA(8)  = BLEC
      RDATA(9)  = DEMEC
      RDATA(10) = TSCEEC
      RDATA(11) = TSCHEC
      RDATA(12) = BSIZEC
      CALL KZPUT1('MCECPAR',0,0,NSEGM,IDATA)

      DO 10 I = 1,NDREC
         IDATA(1) = NDPEC(I)
         CALL KZPUT1('MCECPAR',I,0,1,IDATA)
 10   CONTINUE
      
      RETURN
      END
