      SUBROUTINE GUDIGI
*.
*...GUDIGI   GEANT3 user routine
*.           Simulate the detector responses for the event, using the
*.           information recorded in the data structure JHITS during
*.           particle transport, and store the results in the data 
*.           structure JDIGI.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG
*. CALLS     : MCDIGI CTDIGI BCDIGI ECDIGI VXDIGI BKDUMP
*. CALLED    : GTRIG
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 14-Apr-1994
*. LAST MOD  : 04-Mar-1999
*.
*. MODIFICATION LOG
*. 04-Mar-1999 Nakamura; add ITDIGI
*. 24-Jan-1999 J.Kanzaki,  Added AMDIGI
*. 11-Jan-1999 Y.Fujii,  Added BMDIGI, which was made by Tauchi-san.
*. 29-Jun-1994 N.Hosoda, Add MCDIGI
*. 30-Jun-1994 N.Hosoda, Add BKDUMP
*.
*.**********************************************************************
      IMPLICIT NONE
*
*--   Common for GEANT
#include "geant321/gcflag.inc"

#include "jmfile.inc"

*--   Call each detector part
      CALL MCDIGI
      CALL CTDIGI
      CALL BCDIGI
      CALL ECDIGI
      CALL VXDIGI
      CALL BMDIGI
      CALL AMDIGI
      CALL MUDIGI
      CALL LMDIGI
      CALL ITDIGI

*--   For debug
      IF (ISWIT(5).GE.1) THEN

*--     Dump contents of the bank directory table
        CALL KZDTAB(6)

*--     Print out contents of the specified bank.
        CALL BKDUMP(LUSOJM,'MCHEADER')
        CALL BKDUMP(LUSOJM,'MCCTHIT')
        CALL BKDUMP(LUSOJM,'MCVXHIT')
      ENDIF

CCC      WRITE(6,*) 'GUDIGI ; Exits'

      RETURN
      END
