      SUBROUTINE IRGEOM
*.
*...BCGEOM   Geomtry of the JLC Interaction Region ;
*.           beam pipe, mask, QC, support tube, compensation solenoid.
*.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : UCTMED
*. CALLS     : QCGEOM, MKGEOM, BPGEOM
*. CALLED    : UGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*. AUTHOR    : Yoshiaki Fujii
*. VERSION   : 1.00
*. CREATED   : 128-Aug-1996
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

#include "jmmat.inc"
#include "jmmed.inc"
#include "jmdet.inc"
#include "irgeo.inc"
      
      INTEGER ITUBE,ICOIL

      REAL   PAR(11)
      INTEGER IVOLU
      REAL Z


      IF (ISIMJD(IDETIR).EQ.ISKPJD) RETURN

      ITUBE = NMEDJM*IDETIR+IDIRIR+1
      CALL GSTMED(ITUBE,'TUBE', IMCARB, NOSENS, IFIELD, FIELDM,
     &     TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN,UBUF,NWBUF )
      
      ICOIL = NMEDJM*IDETIR+IDIRIR+2
      CALL GSTMED(ICOIL,'COIL', IMCOIL, NOSENS, NOFILD, 0.,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)

*-- Define geometry of QC1&QC2 for both forward and backward.
      CALL QCGEOM

*-- Define geometry for both fowrard and backward MASK.
      CALL MKGEOM

*-- Define Beam Pipe
      CALL BPGEOM

*-- Define geometry for Support Tube.
      PAR(1) = RRZST(1)
      PAR(2) = RRZST(2)
      PAR(3) = RRZST(3)
      CALL GSVOLU('TUBE','TUBE',ITUBE,PAR,3,IVOLU)
      CALL GSPOS('TUBE',1,'MAST',0,0,0,0,'0NLY')
      
*-- Define geometry for both fowrard and backward 
*-- Compensating Solenoid
      PAR(1) = RRZZCS(1)
      PAR(2) = RRZZCS(2)
      PAR(3) =(RRZZCS(4)-RRZZCS(3)) / 2.0
      CALL GSVOLU('CSFW','TUBE',ICOIL,PAR,3,IVOLU)
      CALL GSVOLU('CSBW','TUBE',ICOIL,PAR,3,IVOLU)
      Z = (RRZZCS(4)+RRZZCS(3)) / 2.0
      CALL GSPOS('CSFW',1,'MAST',0,0, Z,0,'0NLY')
      CALL GSPOS('CSBW',1,'MAST',0,0,-Z,0,'0NLY')

      RETURN
      END      

