      SUBROUTINE ITGEOM
*
*... ITGEOM Geometry of Internal Tracker
*.
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 04-Mar-1999
*. LAST MOD  : 04-Mar-1999
*.
*. MODIFICATION LOG
*. 04-Mar-1999 Nakamura; creation
*.
*.
      IMPLICIT NONE
*
*-- Include files
#include "geant321/gcflag.inc"
#include "jmdet.inc"
#include "jmmat.inc"
#include "jmmed.inc"
#include "itgeo.inc"
#include "ithit.inc"
*
*-- number of bit for detector number
      INTEGER NBITSV
      DATA NBITSV/3/
*
*-- number of bit for each hit parameters
      INTEGER NBITSH(NHIT)
*-- origin of hit parameters
      REAL ORIG(NHIT)
*-- scale factor of hit parameters
      REAL FACT(NHIT)
*-- name of hit parameters
      CHARACTER*4 CHNAMH(NHIT)
*-- Hit parameters
*-- 'X   ' X position  (100.+X)*1.0E4  X in cm
*-- 'Y   ' Y
*-- 'Z   ' Z
*-- 'PX  ' momentum in X direction (500.+PX)*1.0E6  PX in GeV
*-- 'PY  '
*-- 'PZ  '
*-- 'ELOS' Energy loss ELOS*1.0E6  ELOS in GeV
*--
      DATA CHNAMH/'X   ','Y   ','Z   ','PX  ','PY  ','PZ  ','ELOS'/
      DATA NBITSH/    32,    32,    32,    32,    32,    32,    32/
      DATA ORIG  /  100.,  100.,  100.,  500.,  500.,  500.,    0./
      DATA FACT  / 1.0E4, 1.0E4, 1.0E4, 1.0E6, 1.0E6, 1.0E6, 1.0E6/ 

*
*--
      INTEGER ISI,ILAY,IVOL,IDTYP,ISET,IDET
      CHARACTER*4 NAMLIT(MLAYIT)
      REAL PAR(3)
      
*
*-- skip when skip frag
      IF (ISIMJD(IDETIT).EQ.ISKPJD) RETURN
*
*-- define IT tracking medium (silicon)
      ISI = NMEDJM*IDETIT+1
      CALL GSTMED(ISI, 'SIIT', IMSILI, ISENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL,STMIN,UBUF, NWBUF)
*
*-- Define IT geometry
      DO 10 ILAY=1,NLAYIT
*-- names of geometry
*-- Layer Namu
         WRITE(NAMLIT(ILAY),'(''ITL'',I1)') ILAY
*
*-- dimension of layer I
*-- inner radius
         PAR(1) = RIT(ILAY)
*-- outer radius
         PAR(2) = RIT(ILAY)+THIKIT/10000.
*-- inner radius
         PAR(3) = ZLIT(ILAY)
         CALL GSVOLU(NAMLIT(ILAY),'TUBE',ISI,PAR,3,IVOL)
*-- place this layer in MASTER volume         
         CALL GSPOS(NAMLIT(ILAY),ILAY,'MAST',0.,0.,0.,0,'ONLY')
*-- define GEANT DETECOTR
         IDTYP = NDETJM*IDETIT+ILAY
         VNAMIT(ILAY) = NAMLIT(ILAY)
         CALL GSDET('IT  ',VNAMIT(ILAY),NVIT,VNAMIT(ILAY),NBITSV,
     +        IDTYP,NWHIIT,0,ISET,IDET)
*-- define HIT parameter 
         CALL GSDETH('IT  ',VNAMIT(ILAY),NHIT,CHNAMH,NBITSH,ORIG,FACT)
*-- set attribute of this detector if graphic in on
         IF (ISWIT(4).GT.0) CALL GSATT(NAMLIT(ILAY),'SEEN',1)
*         
 10   CONTINUE 
*--  Print SET and DETector parameters
      IF (ISWIT(3) .GE. 1) THEN
        CALL GPSETS('IT  ','*   ')
      ENDIF
*-- done      
      RETURN 
      END
      
      
