***************************************************************************
      SUBROUTINE JMDISC(IPART,IGNEXT,NSTEP,ISTOP,STEP,MEDIUM,IFLAG)
*     OUTPUT iflag : 
*     0 = no problem
*     1 = stop by istop=1
*     2 = stop by istop=2
*     3 = stop by istop=3
*     10= to be stopped ! seems trapped by boundary.... 
*     15= to be stopped ! seems trapped by Magnetic Field.... 
*     20= to be stopped ! nstep nearly reached boundary (10000) 
****************************************************************************
      IMPLICIT NONE

      INTEGER IGNEXT,NSTEP,ISTOP,IFLAG,MEDIUM,IPART
      REAL    STEP

      INTEGER NINNER, NDANGER
      INTEGER LCHECKN, LCHECKN2, LCUTIGC, LMINCHK
      REAL    CUTSTEP, CUTSTEP2
      PARAMETER (LMINCHK=10)
      PARAMETER (LCHECKN=100, LCUTIGC=30, CUTSTEP=1.E-4, CUTSTEP2=1.E-5)
      PARAMETER (LCHECKN2=200)
      INTEGER    MAXDANGER
      PARAMETER (MAXDANGER=300)
      INTEGER IAIR
      PARAMETER (IAIR=2)
      INTEGER NREACH
      PARAMETER (NREACH=9999)

*-- for MSGOUT routine
      CHARACTER*256 CMSG
*--   CERNLIB function
      INTEGER LNBLNK

*-- initialyse iflag
      IFLAG=0
*-- check istop flag
      IF (ISTOP.NE.0) THEN
         IFLAG = ISTOP
         RETURN
      ENDIF

*-- here is for istop = 0

*-- just pass if nstep is small
      IF (NSTEP.LE.LMINCHK) THEN
         NINNER = 0
         NDANGER= 0
         RETURN
      ENDIF

      IF (IGNEXT.EQ.1) THEN
*-- count number of step continuously ignext=1....
         NINNER = NINNER + 1
      ELSEIF (IGNEXT.EQ.0) THEN
*-- reset count
         NINNER = 0
      ENDIF

      IF (NSTEP.GT.LCHECKN .AND. NINNER.GT.LCUTIGC .AND.
     &                           STEP.LT.CUTSTEP) THEN
         IFLAG = 10
         WRITE(CMSG,'(A,E10.5,2I5)')
     &        'SUSPICIOUS .....',STEP,NINNER,IFLAG
         CALL MSGOUT('JMDISC',CMSG(:LNBLNK(CMSG)),1)
         RETURN
      ENDIF

*-- just for electron and positron and proton and pion for Field
      IF (NSTEP.GT.LCHECKN2 .AND. STEP.LT.CUTSTEP2 .AND.
     &     MEDIUM.EQ.IAIR .AND.
     &    (IPART.EQ.2 .OR. IPART.EQ.3 .OR. IPART.EQ.14 .OR.
     &     IPART.EQ.8 .OR. IPART.EQ.9)) THEN
         NDANGER = NDANGER + 1
      ELSEIF (NDANGER.GT.0) THEN
*-- reset
         NDANGER = 0
      ENDIF
*-- just for electron and positron and proton for Field check 
      IF (NDANGER.GT.MAXDANGER) THEN
         IFLAG = 15
         WRITE(CMSG,'(A,E10.5,2I5)')
     &        'TRAP BY FIELD? .....',STEP,NDANGER,IFLAG
         CALL MSGOUT('JMDISC',CMSG(:LNBLNK(CMSG)),2)
         RETURN
      ENDIF

*-- almost reached
      IF (NSTEP.GE.NREACH) THEN
         IFLAG = 20
         WRITE(CMSG,'(A,2I5,E10.5,3I5)')
     &        'ALMOST REACHED TO MAX STEP',
     &        IPART,MEDIUM,STEP,NDANGER,IGNEXT,IFLAG
         CALL MSGOUT('JMDISC',CMSG(:LNBLNK(CMSG)),3)
         RETURN
      ENDIF

      RETURN
      END
