      SUBROUTINE JMKIRD
*.
*...GUKINE   GEANT3 user routine
*.           Decode KINE parameters
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCFLAG GCONST GCKINE 
*. CALLS     : GPKINE GPVERT KI**** GRNDMQ LUGIVE LUEDIT LUHEPC
*.             GSVERT GSKINE JLP2GP
*. CALLED    : GTRIG
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 15-Mar-1999
*. LAST MOD  : 15-Mar-1999
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

*-- Common for GEANT
#include "geant321/gcflag.inc"
#include "geant321/gconst.inc"
#include "geant321/gckine.inc"

#include "jmfile.inc"
#include "jmkine.inc"

      CHARACTER*80 CMSG

      INTEGER LNBLNK
      INTEGER I

*--
*--     1  KILUND  Generates e+e- --> Hadrons with the LUND generator.
*--                CMS Energy is set by 2nd variable on KINE data card.
*--
*--     2  KITOP   Generates a TOP quark event with LUND generator.
*--                TOP MASS is set at 174 GeV.
*--
*--     3  KIHIGS  Generates a HIGGS event. (Yet Available)
*--
*--     4  KISING  Call single particle generator (useful for 
*--                debugging and testing) 
*--
*--     5  KIFILE  Reads Event from FILE Specified in 'input.dat'
*--
*--     6  KIMULT  Call multi-particle generator (useful for 
*--                debugging and testing) 
*--
*--     7  KIOPAL  Read OPAL-specific four-vector files
*--
*--     8  KIXFIL  Reads Event from FILE in old ZBS format
*--
*-- In these subroutines unstables or undetectables are included.

*-- Define Top Mass to 174 GeV & Higgs Mass to 120 GeV
      CALL LUGIVE('PMAS(6,1)=174.0') 
      CALL LUGIVE('PMAS(25,1)=120.0') 
      
      IF (CKINJM.EQ.'LUND') THEN
         IKINE = 1
         PKINE(1) = RKINJM(1)
      ELSEIF (CKINJM.EQ.'LTOP') THEN
         IKINE = 2
         PKINE(1) = RKINJM(1)
         IF (RKINJM(2).GT.0.) THEN
            WRITE(CMSG,'(''PMAS(6,1)='',F5.1)') RKINJM(2)
            CALL LUGIVE(CMSG(:LNBLNK(CMSG)))
         ENDIF
      ELSEIF (CKINJM.EQ.'HIGGS') THEN
         IKINE = 3
         PKINE(1) = RKINJM(1)
         IF (RKINJM(2).GT.0.) THEN
            WRITE(CMSG,'(''PMAS(25,1)='',F5.1)') RKINJM(2)
            CALL LUGIVE(CMSG(:LNBLNK(CMSG)))
         ENDIF
      ELSEIF (CKINJM.EQ.'SINGLE') THEN
         IKINE = 4
         DO 10 I=1,4
            PKINE(I) = RKINJM(I)
 10      CONTINUE
      ELSEIF (CKINJM.EQ.'FILE') THEN
         IKINE = 5
      ELSEIF (CKINJM.EQ.'MULTI') THEN
         IKINE = 6
         DO 20 I=1,10
            PKINE(I) = RKINJM(I)
 20      CONTINUE
      ELSEIF (CKINJM.EQ.'OPAL') THEN
         IKINE = 7
      ELSEIF (CKINJM.EQ.'OLDFILE') THEN
         IKINE = 8
      ELSE
         CALL MSGOUT('JMKIRD',
     &        'Input 4-vector is not specified correctly',1)
      ENDIF

      RETURN
      END
