      SUBROUTINE JMMATE
*.
*...JMMATE   Define the material of all detector parts.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : none
*. CALLS     : GSTMED GSMIXT
*. CALLED    : UGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 16-Mar-1994
*. LAST MOD  : 17-May-1994
*.
*. MODIFICATION LOG
*.
*. 17-May-1994 : Nakamura Isamu
*.             Add the Material 'SCINTI' in #21
*.
*.**********************************************************************
      IMPLICIT NONE
      
#include "jmmat.inc"
      
      INTEGER NISOBU
      PARAMETER (NISOBU=2)
      REAL AISOBU(NISOBU),ZISOBU(NISOBU),DISOBU,WISOBU(NISOBU)
      DATA AISOBU / 12.01,  1.01 /
      DATA ZISOBU /  6.00,  1.00 /
      DATA DISOBU / 0.00267 /
      DATA WISOBU / 4.0, 10.0 /
C      DATA WISOBU / 0.2857, 0.7143 /
      REAL AMISOB

      INTEGER NCO2
      PARAMETER (NCO2=2)
      REAL ACO2(NCO2),ZCO2(NCO2),DCO2,WCO2(NCO2)
      DATA ACO2   / 12.01, 16.01 /
      DATA ZCO2   /  6.00,  8.00 /
      DATA DCO2   / 0.001977 /
      DATA WCO2   / 1.0, 2.0 /
C      DATA WCO2   / 0.33333, 0.66667 /
      REAL AMCO2

      INTEGER NCO2IS
      PARAMETER (NCO2IS=4)
      REAL ACO2IS(NCO2IS),ZCO2IS(NCO2IS),DCO2IS,WCO2IS(NCO2IS)
      DATA ACO2IS / 12.01, 1.01, 12.01, 16.01 /
      DATA ZCO2IS /  6.00, 1.00,  6.00,  8.00 /
      DATA DCO2IS / 0.0020463 /
      REAL RISOBU,RCO2,RCO2IS
      PARAMETER (RISOBU=0.1, RCO2=0.9)

      INTEGER NSCIN
      PARAMETER (NSCIN=3)
      REAL ASCIN(NSCIN),ZSCIN(NSCIN),DSCIN,WSCIN(NSCIN)
      DATA ASCIN  /   1.0,  12.0,  16.0 /
      DATA ZSCIN  /   1.0,   6.0,   8.0 /
      DATA WSCIN  /   0.080, 0.600, 0.320 /
      DATA DSCIN  /   1.20 /

      INTEGER NCOIL
      PARAMETER (NCOIL=4)
      REAL ACOIL(NCOIL),ZCOIL(NCOIL),DCOIL,WCOIL(NCOIL)
      DATA ACOIL  /  92.9,  47.9,  63.5, 4.0 /
      DATA ZCOIL  /  41.0,  22.0,  29.0, 2.0 /
      DATA WCOIL  / 0.015, 0.012, 0.969, 0.004 /
      DATA DCOIL  /   7.4 /

*--           G10 mixture.
*--           AG10 = Atomic masses (Carbon, Oxygen, Silicon)
*--           ZG10 = Atomic numbers (ditto)
*--           WG10 = Proportions by mass.
      INTEGER NG10
      PARAMETER (NG10=3)
      REAL AG10(NG10),ZG10(NG10),DG10,WG10(NG10)
      DATA AG10  /   12.01,   16.0,   28.09 /
      DATA ZG10  /     6.0,    8.0,   14.0 /
      DATA WG10  /  0.2400,  0.4795,  0.2805 / 
      DATA DG10  / 1.7 /

      REAL ASILI,ZSILI,DSILI,RDSILI,ABSILI
      PARAMETER (ASILI=28.09, ZSILI=14.0, DSILI=2.33)
      PARAMETER (RDSILI=9.36, ABSILI=45.5)
      
      INTEGER NWBUF
      PARAMETER (NWBUF=1)
      REAL UBUF(NWBUF)

      INTEGER I


*--   Define mixture or compound as composed by some materials
*--   Isobuthan
      AMISOB = 0.
      DO 10 I=1,NISOBU
         AMISOB = AMISOB + AISOBU(I)*WISOBU(I)
 10   CONTINUE

      CALL GSMIXT(IMISOB,'ISOBUTHAN$',AISOBU,ZISOBU,DISOBU*RISOBU,
     &     -NISOBU,WISOBU)

*--   CO2
      AMCO2 = 0.
      DO 20 I=1,NCO2
         AMCO2 = AMCO2 + ACO2(I)*WCO2(I)
 20   CONTINUE

      CALL GSMIXT(IMCO2,'CO2$',ACO2,ZCO2,DCO2*RCO2,-NCO2,WCO2)

*--   CO2/Isobuthan
      WCO2IS(1)=WISOBU(1)*RISOBU*AMISOB
      WCO2IS(2)=WISOBU(2)*RISOBU*AMISOB
      WCO2IS(3)=WCO2(1)*RCO2*AMCO2
      WCO2IS(4)=WCO2(2)*RCO2*AMCO2
      RCO2IS = RISOBU*AMISOB + RCO2*AMCO2

      DO 30 I=1,NCO2IS
         WCO2IS(I) = WCO2IS(I)/RCO2IS
 30   CONTINUE 

      CALL GSMIXT(IMCO2I,'CO2/ISOBU$',
     &     ACO2IS,ZCO2IS,DCO2IS,NCO2IS,WCO2IS)

      CALL GSMIXT(IMSCIN,'SCINTI$',ASCIN,ZSCIN,DSCIN,NSCIN,WSCIN)

      CALL GSMIXT(IMCOIL,'COIL$',ACOIL,ZCOIL,DCOIL,NCOIL,WCOIL)

*--   Stores the constants for the material in the DATA structure JMATE
      CALL GSMATE(IMSILI,'SILICON$', ASILI,ZSILI,DSILI,
     &     RDSILI,ABSILI, UBUF,NWBUF)

      CALL GSMIXT(IMG10,'G10$',AG10,ZG10,DG10,NG10,WG10)

      RETURN
      END
