      SUBROUTINE JMSPAR
*.
*...JMSPAR   Saves JIM parameters
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. COMMON    : GCCUTS GCPHYS
*. CALLS     : nom
*. CALLED    : JMSAVP
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 27-Feb-1999
*.
*.*********************************************************************
*.
*.     +-------------------------+
*.     | Bank Name  :  MCJIMPAR  |
*.     +-------------------------+
*.
*.     Contents    : Information of JIM Parameters are stored.
*.     Record Type : 1-dim. fixed length segment
*.     Version     : Release 1.0  1999-Feb-27
*.
*.*********************************************************************
*.
*.(1) Contents in the Master Segment
*.----------------------------------
*.
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. IDATA(1)   Version Number of JIM (= 10000*Major#+100*Minor#+Update#)
*. Cuts on forward particles in smearing mode
*. RDATA(2)   radius for defining forward region
*. RDATA(3)   |z| cuts for defining forward region
*. RDATA(4)   angle cut in radian
*. RDATA(5)   pt cuts for forward particles
*. IDATA(6)   Number of Detectors (= NDMXJD)
*.(2) Contents in the Data Segment
*.    Segment # = detector # (see "jmdet.inc")
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. IDATA(1)         Detector simulation flags  
*.
*.**********************************************************************
      IMPLICIT NONE

#include "jmvers.inc"
#include "jmdet.inc"
#include "jmstep.inc"

      INTEGER NWMAST
      PARAMETER (NWMAST=6)
      CHARACTER*32 CFMAST
      PARAMETER (CFMAST = '1I 4F 1I')
      INTEGER NSEGM,LSEGM
      PARAMETER (NSEGM=NDMXJD, LSEGM=1)
      CHARACTER*32 CFSEGM
      PARAMETER (CFSEGM = '1I')

      INTEGER NPDATA
      PARAMETER (NPDATA=10)
      INTEGER IDATA(NPDATA)
      REAL    RDATA(NPDATA)
      EQUIVALENCE (RDATA(1),IDATA(1))


      INTEGER I,IERR

      CALL KZBCR1('MCJIMPAR',
     &     NWMAST,CFMAST,NSEGM,LSEGM,CFSEGM,IERR)

*-- Create ZBS Bank MCGEPAR
      IDATA(1) = 10000*IMAJJM+100*IMINJM+IUPDJM
      RDATA(2) = RDFWJM
      RDATA(3) = ZFWJM
      RDATA(4) = THFWJM
      RDATA(5) = PTFWJM
      IDATA(6) = NDMXJD

      CALL KZREP1('MCJIMPAR',0,NWMAST,IDATA)

      DO 10 I=1,NDMXJD
         IDATA(1) = ISIMJD(I)
         CALL KZREP1('MCJIMPAR',I,LSEGM,IDATA)
 10   CONTINUE

      RETURN
      END
