      SUBROUTINE JMTMED
*.
*...JMTMED   Define the tracking medium of all detector parts.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : UCTMED
*. CALLS     : GSTMED
*. CALLED    : UGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 16-Mar-1994
*. LAST MOD  : 18-May-1994
*.
*. MODIFICATION LOG
*.
*. 17-May-1994 : Nakamura Isamu
*.             Add the Tracking Medium 'SCINTI' 
*. 18-May-1994 : Nakamura Isamu
*.           : Common Block UCTMED
*. 21-Jun-1994 N.Hosoda, Add CFRP,ALUM
*. 25-Apr-1995 Y.Fujii, add insensitive silicon (TMSIBK) for Si backplane.
*.                    All initial values are set to Parameter Statement.
*. 11-May-1995 Y.Fujii, add precision tracking Air (#18) for precision
*.                    pixel tracking.
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Include COMMON BLOCK UCTMED
c#include "gctrak.inc"
#include "jmmat.inc"
#include "jmmed.inc"

      
*--   Stores the parameter of the tracking medium in the data structure
*--   JTMED
      CALL GSTMED(IAIRJM, 'AIR', IMAIR, NOSENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)

      CALL GSTMED(IVACJM, 'VACUUM', IMVAC, NOSENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)

      RETURN
      END
