      SUBROUTINE JMVTKI
*.
*...JMVTKI    Determine VTX and KINEmatics.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : HEPEVT
*. CALLS     : 
*. CALLED    : GUKINE
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 25-Mar-1996
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.     23-Aug-1996 Y.Fujii ; Added scan for 1st stable particle. Without this,
*.                           1st particle always included in the list.
*.                           KINBUF(3,N) corrected to KINBUF(5,N)
*.     26-Aug-1996 Y.Fujii ; Fixed a bug about ITRVTX(1). It was not filled
*.                           when there is only one stable particle.
*.
*.**********************************************************************
*.*********************************************************************
*.     +------------------------+                                     *
*.     | Bank Name  :  MCVERTEX |                                     *
*.     +------------------------+                                     *
*.                                                                    *
*.     Contents    : List of Verteceis
*.                                                                    *
*.     Record Type : 1-dim. variable length segment                   *
*.     Version     : Release 1.0  25-Mar-1996                         *
*.                                                                    *
*.*********************************************************************
*.
*.(1) Contents in the Master Segment
*.----------------------------------
*.
*.---------------------------------------------------------------------
*.  DATA                            CONTENTS
*.---------------------------------------------------------------------
*. IDATA(1)      # of vertecies
*.---------------------------------------------------------------------
*.(2) Contents in the Data Segment
*.--------------------------------
*.
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. RDATA(1)      vertex X position in cm
*. RDATA(2)      vertex Y position in cm
*. RDATA(3)      vertex Z position in cm
*. RDATA(4)      production time.
*.**********************************************************************
*.
*.*********************************************************************
*.     +------------------------+                                     *
*.     | Bank Name  :  MCTRACK  |                                     *
*.     +------------------------+                                     *
*.                                                                    *
*.     Contents    : List of Tracks
*.                                                                    *
*.     Record Type : 1-dim. variable length segment                   *
*.     Version     : Release 1.0  25-Mar-1996                         *
*.                                                                    *
*.*********************************************************************
*.
*.(1) Contents in the Master Segment
*.----------------------------------
*.
*.---------------------------------------------------------------------
*.  DATA                            CONTENTS
*.---------------------------------------------------------------------
*. IDATA(1)      # of Tracks
*.---------------------------------------------------------------------
*.(2) Contents in the Data Segment
*.--------------------------------
*. 
*.----------------------------------------------------------------------
*.  DATA                            CONTENTS
*.----------------------------------------------------------------------
*. RDATA(1)      momentum px
*. RDATA(2)      momentum py
*. RDATA(3)      momentum pz
*. RDATA(4)      energy   E
*. RDATA(5)      mass 
*. IDATA(6)      particle ID (LUND code)
*. IDATA(7)      particle ID (GEANT code)
*. IDATA(8)      pointer to MCVERTEX
*. IDATA(9)      pointer to MCEVENT
*.**********************************************************************
      IMPLICIT NONE
* Common
#include "hepevt.inc"

#include "jmfile.inc"

      REAL VTXBUF(4,NMXHEP),VERTEX(3),UBUF
      REAL KINBUF(5,NMXHEP),PLAB(3)
      INTEGER NVERT,ITRVTX(NMXHEP),NUBUF,ITRHEP(NMXHEP),IERR
      INTEGER IDPTCL(2,NMXHEP),NTRA,IGEAN,IHEP,ISEG
      PARAMETER(NUBUF=1)

      INTEGER IDATA(9)
      REAL RDATA(9)
      EQUIVALENCE (IDATA(1),RDATA(1))

      INTEGER NWMVTX,LSGVTX
      PARAMETER (NWMVTX=1, LSGVTX=4)
      CHARACTER*32 FMSVTX,FSGVTX
      PARAMETER (FMSVTX='1I', FSGVTX='4F')

      INTEGER NWMTRK,LSGTRK
      PARAMETER (NWMTRK=1, LSGTRK=9)
      CHARACTER*32 FMSTRK,FSGTRK
      PARAMETER (FMSTRK='1I', FSGTRK='5F 4I')

      INTEGER I,K

      
*-- Initail value
      NVERT = 0
      NTRA = 0

*-- Loop over particles in the HEPEVT
      DO 100 IHEP=1,NHEP

*-- Skip unstable particle
         IF (ISTHEP(IHEP).EQ.1) THEN
            NTRA = NTRA + 1
            ITRHEP(NTRA) = IHEP
            DO 110 K=1,5
               KINBUF(K,NTRA) = PHEP(K,IHEP)
 110        CONTINUE 
            IDPTCL(1,NTRA) = IDHEP(IHEP)
            CALL JLP2GP(IDHEP(IHEP),IGEAN,IERR)
            IDPTCL(2,NTRA) = IGEAN
            
            IF (NVERT.GE.1) THEN
*-- Look for Vertex of the Track
               DO 120 K = 1,NVERT
                  IF (VHEP(1,IHEP).EQ.VTXBUF(1,K) .AND.
     &                 VHEP(2,IHEP).EQ.VTXBUF(2,K) .AND.
     &                 VHEP(3,IHEP).EQ.VTXBUF(3,K) .AND.
     &                 VHEP(4,IHEP).EQ.VTXBUF(4,K)) THEN
                     ITRVTX(NTRA) = K
                     GOTO 100
                  ENDIF 
 120           CONTINUE
            ENDIF
            
*-- If no corresponding Vertex, add them to the Vertex Buffer
            NVERT = NVERT + 1
            ITRVTX(NTRA) = NVERT
            DO 130 K=1,4
               VTXBUF(K,NVERT) = 0.1*VHEP(K,IHEP)
 130        CONTINUE
         ENDIF
 100  CONTINUE
      
*-- Create and Fill MCVERTEX
      CALL KZBCR1('MCVERTEX',NWMVTX,FMSVTX,NVERT,LSGVTX,FSGVTX,IERR) 

*-- Store Data to Master Segment
      IDATA(1) = NVERT
      CALL KZREP1('MCVERTEX',0,NWMVTX,IDATA)
      
*-- Store Data to given Segment of Bank MCVERTEX
      DO 200 ISEG = 1,NVERT
C         CALL UCOPY(VTXBUF(1,ISEG),RDATA(1),4)
         DO 210 K=1,4
            RDATA(K) = VTXBUF(K,ISEG)
 210     CONTINUE
         CALL KZREP1('MCVERTEX',ISEG,LSGVTX,IDATA)
 200  CONTINUE
      
*-- Create and Fill MCTRACK
      CALL KZBCR1('MCTRACK',NWMTRK,FMSTRK,NTRA,LSGTRK,FSGTRK,IERR)
      
*-- Store Data to Master Segment
      IDATA(1) = NTRA
      CALL KZREP1('MCTRACK',0,NWMTRK,IDATA)
      
*-- Store Data to given Segment of Bank MCTRAK
      DO 300 ISEG = 1,NTRA
         DO 310 K=1,5
            RDATA(K) = KINBUF(K,ISEG)
 310     CONTINUE
         DO 320 K=1,2
            IDATA(K+5) = IDPTCL(K,ISEG)
 320     CONTINUE
         IDATA(8) = ITRVTX(ISEG)
         IDATA(9) = ITRHEP(ISEG)
         CALL KZREP1('MCTRACK',ISEG,LSGTRK,IDATA)
         IDATA(1) = ISEG
         CALL KZPUT1('MCEVENT',ITRHEP(ISEG),18,1,IDATA)
 300  CONTINUE
      
*-- Fill the GEANT DATA structure JVERTX and JKINE
*   (1) JVERTX (Vertex)
      DO 400 I=1,NVERT
         DO 410 K=1,3
            VERTEX(K) = VTXBUF(K,I)
 410     CONTINUE
*-- Store Vertex Time of flight into UBUF
         UBUF = VTXBUF(4,I)
         CALL GSVERT(VERTEX, 0, 0, UBUF, NUBUF, IERR)
         IF (IERR.EQ.0) THEN
            CALL MSGOUT('JMVTKI','GSVERT error',IERR)
         ENDIF
 400  CONTINUE
      
*   (2) JKINE (Trak)
      DO 500 I = 1, NTRA
         DO 510 K=1,3
            PLAB(K) = KINBUF(K,I)
 510     CONTINUE
c        print *,'jmvtki;i,id,plab = ',i,idptcl(2,i),plab
         CALL GSKINE(PLAB,IDPTCL(2,I),ITRVTX(I),0, 0, IERR)
         IF (IERR.EQ.0) THEN
            WRITE(LUSOJM,6001) I, PLAB, IDPTCL(2,I), ITRVTX(I)
 6001       FORMAT(1H ,'!!! GSKINE error in jmvtki.f at', I4,
     &           '-th track' ,
     &           /1H ,'  PLAB =', 3F10.3
     &           /1H ,'P-CODE =',  I10
     &           /1H ,'ITRVTX =',  I10 / )
         ENDIF   
 500  CONTINUE
      
      RETURN
      END

         
