CDECK  ID>, KISTBL.
      SUBROUTINE  KISTBL (NTRAK,IPART,IPOINT,IFIND)
*.
*...KISTBL
*. Routine to determine whether a particle positioned in an event
*. generator event record is stable or not as determined by
*. whether it has any daughters
*.
*. SEQUENCE  : none
*. INPUT     : NTRAK    Number of entries in the event record
*. INPUT     : IPART    Position of the particle in the event record
*. INPUT     : IPOINT   Particle history record for the event
*. OUTPUT    : IFIND    = 1 if the particle is stable
*.                      = 0 if not
*. CALLS     : none
*. CALLED    : By User
*.
*. AUTHOR    :  J.W.Gary
*. CREATED   :  19-Apr-1989
*. LAST MOD  :  19-Apr-1989
*.
*. Modification Log.
*.
*.********************************************************************
      IMPLICIT NONE
      INTEGER  IPART,IFIND,INX,NTRAK,IPAR
      INTEGER  IPOINT (*)

      IFIND = 1
      INX = IPART
 100  INX = INX + 1
          IF (INX.GT.NTRAK) GO TO 990
          IPAR = IPOINT (INX)
          IF (IPAR.EQ.IPART) THEN
              IFIND = 0
              GO TO 990
          ENDIF
      GO TO 100

 990  RETURN
      END
