      SUBROUTINE KIXFIL
*.
*...KIFILE Gets Event from File Specified in 'input.dat'
*.
*. SEQUENCE  : ........
*. CALLS     : KZFILE KZREAD KZNSEG KZGET1 KZECLR
*. CALLED    : GUKINE
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 13-Jul-1994
*. LAST MOD  : 10-Aug-1994
*.
*. Modification Log.
*. 19-Nov-1998 J.Kanzaki  ; Added KZECLR fixed bug in case of event skip
*.  3-Sep-1996 Y.Fujii    ; Added 'GENHEADER' read-out to get Ebeam
*. 11-May-1995 Nakamura.I ; Replace DYALLC with JUALLC
*. 10-Aug-1994 N.HOSODA   ; change DATA(15),IDATA(15) to DATA(20),IDATA(20)
*.
*.*********************************************************************
      IMPLICIT NONE

#include "geant321/gcflag.inc"
#include "geant321/gckine.inc"
      
#include "jetset.inc"
#include "hepevt.inc"

#include "jmcntl.inc"
#include "jmfile.inc"
#include "mchead.inc"      
      
      REAL RDATA(20)
      INTEGER IDATA(20)
      EQUIVALENCE (RDATA(1),IDATA(1))

      INTEGER IFLAG
      INTEGER I,IERR

      INTEGER ISEG,NDATA,NSEGM,NMDATA

      LOGICAL LEXIST
      
      INTEGER IFORM
      PARAMETER (IFORM=-1)
      CHARACTER*80 CMSG

      INTEGER LNBLNK


*-- OPEN File 
      IF (IEVENT.EQ.1) THEN

         IF (LUNMJM(IFILFI).LE.0) THEN
            CALL MSGOUT('KIFILE','Logical unit number is wrong',
     &           LUNMJM(IFILFI))
            STOP
         ENDIF

         INQUIRE(FILE=FNAMJM(IFILFI)(:LNBLNK(FNAMJM(IFILFI))),
     &        EXIST=LEXIST)

         IF (.NOT.LEXIST) THEN
            WRITE(CMSG,
     &           '(''Specified file does not exist for '',A4, 
     &           '':'',A)') CTAGJM(I),
     &           FNAMJM(IFILFI)(:LNBLNK(FNAMJM(IFILFI)))
            CALL MSGOUT('KIFILE',CMSG(:LNBLNK(CMSG)),1)
            STOP
         ELSE
            CALL KZXOPE(LUNMJM(IFILFI),
     &           FNAMJM(IFILFI)(:LNBLNK(FNAMJM(IFILFI))),
     &           IERR)
            IF (IERR.NE.0) THEN
               CALL MSGOUT('KIFILE','File allocation error',IERR)
               STOP
            ENDIF
            
         ENDIF
         
c         WRITE(6,*)
c         WRITE(6,*) 'Event Data is read from >>> ',FNAMJM(IFILFI)
c         WRITE(6,*)

*-- Read 1 Event from File. Skip NSKPJM events before reading.
         IF (NSKPJM.GE.1) THEN
            DO I=1,NSKPJM
               CALL KZECLR
               CALL KZREAD(LUNMJM(IFILFI),IFLAG)
               IF (IFLAG.NE.0) THEN
                  IEORUN = 1
                  RETURN
               ENDIF
            ENDDO
         ENDIF

      ENDIF

      CALL KZECLR
      CALL KZREAD(LUNMJM(IFILFI),IFLAG)
      IF (IFLAG.NE.0) THEN
         IEORUN = 1
         RETURN
      ENDIF

*-- GET Master Segment DATA of Bank MCEVENT
      CALL KZNSEG('MCEVENT',NSEGM)
      CALL KZGET('MCEVENT',0, NMDATA,IDATA)
      NEVHEP = IDATA(1)
      NHEP   = IDATA(2)
c      WRITE(6,*) 'In kifile; MCEVENT Header=',IDATA(1),IDATA(2)

*-- Store Data to given Segment of Bank MCEVENT
      DO 10 ISEG=1,NHEP
         CALL KZGET('MCEVENT',ISEG,NDATA,IDATA)
         ISTHEP(ISEG)   = IDATA(1)
         IDHEP(ISEG)    = IDATA(2)
         JMOHEP(1,ISEG) = IDATA(3)
         JMOHEP(2,ISEG) = IDATA(4)
         JDAHEP(1,ISEG) = IDATA(5)
         JDAHEP(2,ISEG) = IDATA(6)
         PHEP(1,ISEG)   = RDATA(8)
         PHEP(2,ISEG)   = RDATA(9)
         PHEP(3,ISEG)   = RDATA(10)
         PHEP(4,ISEG)   = RDATA(11)
         PHEP(5,ISEG)   = RDATA(12)
         VHEP(1,ISEG)   = RDATA(13)*10.
         VHEP(2,ISEG)   = RDATA(14)*10.
         VHEP(3,ISEG)   = RDATA(15)*10.
         VHEP(4,ISEG)   = RDATA(16)*10.
 10   CONTINUE

*-- Read MC Data from 'GENHEADER'
 5000 CONTINUE
      CALL KZGET('GENHEADER',0,NDATA,IDATA)
      EBMMC = (RDATA(13)+RDATA(18))/2.0

      RETURN
      END
