      SUBROUTINE MCBFHD
*.
*.
*...MCBFHD   JIM utility tool Create & Fill one HEPEVT Common 
*.           Event to MCEVENT BANK
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : HEPEVT
*. CALLS     : KZBCR1 KZPUT1
*. CALLED    : GUKINE
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 9-July-1994
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.   3-SEP-1996, Y.FUJII ; Added GENHEADER 
*.  
*.**********************************************************************
      IMPLICIT NONE

#include "geant321/gckine.inc"

#include "hepevt.inc"
#include "jetset.inc"

      INTEGER     IDATA(20)
      REAL        RDATA(20)
      CHARACTER*4 CDATA(20)
      EQUIVALENCE (RDATA(1),IDATA(1))
      EQUIVALENCE (RDATA(1),CDATA(1))

      INTEGER NWMGNH,NSGGNH,LSGGNH
      PARAMETER (NWMGNH=19, NSGGNH=0, LSGGNH=0)
      CHARACTER*32 FMSGNH,FSGGNH
      PARAMETER (FMSGNH='1H 7I 11F', FSGGNH=' ')

      INTEGER NWMMCE,LSGMCE
      PARAMETER (NWMMCE=2, LSGMCE=19)
      CHARACTER*32 FMSMCE,FSGMCE
      PARAMETER (FMSMCE='2I', FSGMCE='7I 11F 1I')

      INTEGER IT,ID

      INTEGER LUCHGE
      REAL CTAU

      INTEGER ISEG

      INTEGER IERR
      
*-- Create ZBS Bank GENHEADER 
      CALL KZBCR1('GENHEADER',
     &     NWMGNH,FMSGNH,NSGGNH,LSGGNH,FSGGNH,IERR)

*-- Store Data to Master Segment of Bank GENHEADER
      CALL JUTIME(ID,IT)
      
      IF (IKINE.EQ.1 .OR. IKINE.EQ.2 .OR. IKINE.EQ.3) THEN
         CDATA(1)  = 'PYTH'
         IDATA(2)  = 57
      ELSEIF (IKINE.EQ.4) THEN
         CDATA(1)  = 'SING'
         IDATA(2)  = 1
      ELSEIF (IKINE.EQ.6) THEN
         CDATA(1)  = 'MULT'
         IDATA(2)  = 1
      ENDIF
      
      IDATA(3)  = ID
      IDATA(4)  = IT
      IDATA(5)  = NEVHEP
      IDATA(6)  = NHEP
      IDATA(7)  = 0
      IDATA(8)  = 0
      RDATA(9)  = PKINE(1)
      RDATA(10) = 0.
      RDATA(11) = 0.
      RDATA(12) = PKINE(1)/2.
      RDATA(13) = PKINE(1)/2.
      RDATA(14) = 0.
      RDATA(15) = 0.
      RDATA(16) = 0.
      RDATA(17) = PKINE(1)/2.
      RDATA(18) = PKINE(1)/2.
      RDATA(19) = 0.
      CALL KZREP1('GENHEADER',0,NWMGNH,IDATA)
      
*-- Create ZBS Bank MCEVENT to Store Primary State Information of Event.
      CALL KZBCR1('MCEVENT',NWMMCE,FMSMCE,NHEP,LSGMCE,FSGMCE,IERR)
      
*-- Store Data to Master Segment of Bank MCEVENT 
      IDATA(1) = NEVHEP
      IDATA(2) = NHEP
      CALL KZREP1('MCEVENT',0,NWMMCE,IDATA)
      
*-- Store Data to given Segment of Bank MCEVENT 
      DO 10 ISEG=1,NHEP
         
*-- Get Particle Charge & Life
         CALL LUCTAU(IDHEP(ISEG),CTAU)
         CHARGE    = LUCHGE(IDHEP(ISEG))/3.

         IDATA(1)  = ISTHEP(ISEG)
         IDATA(2)  = IDHEP(ISEG)
         IDATA(3)  = JMOHEP(1,ISEG)
         IDATA(4)  = JMOHEP(2,ISEG)
         IDATA(5)  = JDAHEP(1,ISEG)
         IDATA(6)  = JDAHEP(2,ISEG)
         IDATA(7)  = 0
         RDATA(8)  = PHEP(1,ISEG)
         RDATA(9)  = PHEP(2,ISEG)
         RDATA(10) = PHEP(3,ISEG)
         RDATA(11) = PHEP(4,ISEG)
         RDATA(12) = PHEP(5,ISEG)
         RDATA(13) = VHEP(1,ISEG)/10.
         RDATA(14) = VHEP(2,ISEG)/10.
         RDATA(15) = VHEP(3,ISEG)/10.
         RDATA(16) = VHEP(4,ISEG)/10.
         RDATA(17) = CHARGE
         RDATA(18) = CTAU
         IDATA(19) = 0
         CALL KZREP1('MCEVENT',ISEG,LSGMCE,IDATA)
 10   CONTINUE

      RETURN
      END
