      SUBROUTINE MUDIGI
*.
*...MUDIGI   Compute and store DIGIts for muon detectors
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : CTGEO  GCNUM
*. CALLS     : GFHITS KZBCR1 KZBCR0 KZPUT1 KZPUT0 JGP2LP
*. CALLED    : GUDIGI
*.
*. BANKS L   : MCMUHIT
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 28-Jan-1999
*. LAST MOD  : 28-Jan-1999
*.
*. MODIFICATION LOG
*.   03-Mar-1999 Nakamura; correct master segment format
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common
#include "geant321/gcnum.inc"

#include "mugeo.inc"
#include "muhit.inc"

      INTEGER NHMXTT
      PARAMETER (NHMXTT=50000)
      INTEGER NUMVS(NDSVMU),NUMBV(NDSVMU,NHMXMU),
     &     ITRA(NHMXMU)
      REAL    HITS(NDHTMU,NHMXMU)
      INTEGER NHITS

      INTEGER NDATMX
      PARAMETER (NDATMX=19)
      INTEGER   IDATA(NDATMX)
      REAL      RDATA(NDATMX)
      EQUIVALENCE (IDATA(1), RDATA(1))

      INTEGER NUMHIT,IHIT

*--   Parameter for bank 'MCMUHIT'
      CHARACTER*32 CFMMUH,CFSMUH
      INTEGER NWMMUH,LSEMUH,NWPMUH,NDAMUH
      PARAMETER (NWMMUH=1)
      PARAMETER (CFMMUH='1I')
      PARAMETER (LSEMUH=14)
      PARAMETER (CFSMUH='2I 2F 2I 8F')
      PARAMETER (NWPMUH=0)
      PARAMETER (NDAMUH=LSEMUH)

*--   Parameter for the bank 'MCCTHIT-TRACK'
*      CHARACTER*2 CFMCTT,CFSCTT
*      INTEGER NWMCTT,LSGCTT
*      PARAMETER (NWMCTT=1, LSGCTT=1)
*      PARAMETER (CFMCTT='1I')
*      PARAMETER (CFSCTT='1I')

      INTEGER ILPC

      CHARACTER*80 CMSG
      INTEGER LNBLNK

      INTEGER IADDR
      INTEGER IDC
      INTEGER I,J,IHT,IERR


*--   Initialize
      DO 10 I=1,NDSVMU
         NUMVS(I)=0
 10   CONTINUE
*
      NUMHIT=0
*-- loop over sector (octant)
      DO 20 I=1,NSECMU
*-- loop over layers
         DO 25 IDC=1,NLAYMU
*--     Retrieve HITS produced by tracks
            CALL GFHITS('MU  ',VNAMMU(IDC,I),NDSVMU,NDHTMU,NHMXMU,0,
     &           NUMVS,ITRA,NUMBV,HITS,NHITS)
            IF (NHITS.GT.NHMXMU) THEN
               WRITE(CMSG,'(''Nhits overflow for Layer:'',I2,
     &              '', Anode:'',I2)') I,IDC
               CALL MSGOUT('MUDIGI',CMSG(1:LNBLNK(CMSG)),NHMXMU)
               NHITS = NHITS-1
            ENDIF
            NUMHIT = NUMHIT+NHITS
 25      CONTINUE
 20   CONTINUE

c      print *,'mudigi;numhit = ',numhit
*--   Create new ZBS bank with the 1-dim. fixed length segment.
      CALL KZBCR1('MCMUHIT',NWMMUH,CFMMUH,NUMHIT,LSEMUH,CFSMUH, IERR)

      IHIT = 0
      DO 100 I=1,NSECMU
         DO 110 IDC=1,NLAYMU
            CALL GFHITS('MU  ',VNAMMU(IDC,I),NDSVMU,NDHTMU,NHMXMU,0,
     &           NUMVS,ITRA,NUMBV,HITS,NHITS)
            IF (NHITS.GT.NHMXMU) THEN
               NHITS = NHMXMU
            ENDIF    

            DO 120 IHT=1,NHITS
               IHIT = IHIT+1
               IDATA(1) =ITRA(IHT)
               IADDR = 0
               IDATA(2) =IADDR
*--      Convert geant p-code to LUND74 P-code
               CALL JGP2LP(NINT(HITS(1,IHT)), ILPC,IERR)
               IF (IERR .EQ. 0) THEN
                  IDATA(3) =ILPC
               ELSE
                  IDATA(3) =9999
               ENDIF
               DO 130 J=2, NDHTMU
                  RDATA(J+2) = HITS(J,IHT)
 130           CONTINUE 

c               print *,'mudigi;ihit = ',ihit
c               print *,'      ;idata = ',(idata(j),j=1,3)
c               print *,'      ;rdata = ',(rdata(j),j=4,11)
c               print *,'      ;rdata = ',(rdata(j),j=12,19)
*--     Put data words into the given segment of the bank
               CALL KZPUT1('MCMUHIT',IHIT,NWPMUH,NDAMUH,RDATA)

 120        CONTINUE
 110     CONTINUE
 100  CONTINUE      
      
      RETURN
      END
