      SUBROUTINE MUGEOM
*.
*...MUGEOM   Geomtry of the JLC MUON Chamber.
*.
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : UCTMED
*. CALLS     : 
*. CALLED    : UGEOM
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*. AUTHOR    : Yoshiaki Fujii
*. VERSION   : 1.00
*. CREATED   : 12-May-1995
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
      IMPLICIT NONE

#include "geant321/gconst.inc"

#include "jmmed.inc"
#include "jmmat.inc"
#include "jmdet.inc"
#include "mugeo.inc"      
#include "muhit.inc"      
      
      INTEGER ICO2I
      
CCCCC REAL      XMASMU, YMASMU, ZMASMU, 
CCCCC&          FVERT, FHORIZ, FTHICK, RVERT, RHORIZ, RTHICK,
      CHARACTER*4   CNAME, CNAME2, CNAME3
      REAL PAR(11)
CCCCC DATA XMASMU, YMASMU, ZMASMU / 800., 800., 1000. /      

      INTEGER IS,IL
      REAL PHI
      REAL X,Y,Z
      REAL PHIDX,PHIDY
      INTEGER IROT,IVOLU
      INTEGER IAX,NDIV

      CHARACTER*4 CHNMMU(NDSVMU)
      INTEGER NBITSV(NDSVMU)
      DATA NBITSV/  8,  8,  8/
      
      CHARACTER*4 CHNMUH(NDHTMU)
      DATA CHNMUH /  'PCOD','X1  ','Y1  ','Z1  ','E1  ',
     &     'PX1 ','PY1 ','PZ1 ','T1  ','X2  ','Y2  ','Z2  ',
     &     'E2  ','PX2 ','PY2 ','PZ2 ','T2  '/
      INTEGER NBITSH(NDHTMU)
      REAL ORIG(NDHTMU),FACT(NDHTMU)
      DATA NBITSH/ 1*16,16*32 /
      DATA ORIG/ 30000.,3*1000.,0.,3*500.,0.,
     &     3*1000.,0.,3*500.,0./
      DATA FACT/ 1., 3*1.E6, 1.E6, 3*1.E6, 1.E2,
     &     3*1.E6, 1.E6, 3*1.E6, 1.E2/

      INTEGER ISET,IDET,IDTYPE


      IF (ISIMJD(IDETMU).EQ.ISKPJD) RETURN

      ICO2I = NMEDJM*IDETMU+1
      CALL GSTMED(ICO2I, 'CO2ISO', IMCO2I, ISENS, IFIELD, FIELDM,
     &     TMAXFD, STEMAX, DEEMAX, EPSIL, STMIN, UBUF, NWBUF)

*-- Octal Barrel Muons. 
*-- Octant number increases counter-clockwise, and 3 o'clock=1
*-- Define octant, define layer, devide to cell 
      DO 101 IS=1,NSECMU
         WRITE(CNAME,'(''MUB'',I1)') IS
         PAR(1) = BWIDMU(IS)/2.
         PAR(2) = BTHKMU(IS)/2.
         PAR(3) = BLNGMU(IS)/2.
c         print *,'mugeom;is = ',is
c         print *,'      ;par = ',(par(j),j=1,3)
         CALL GSVOLU(CNAME,'BOX ',IAIRJM,PAR,3,IVOLU)
         CHNMMU(1) = CNAME
         PHI = PI / 4. * FLOAT(IS-1)
         X = BRADMU * COS(PHI)
         Y = BRADMU * SIN(PHI)
         Z = 0.
         PHIDY = 45. * FLOAT(IS-1)
         PHIDX = PHIDY - 90.
         IROT = NROTJM*IDETMU+IS
         CALL GSROTM(IROT,90.,PHIDX,90.,PHIDY,0.,0.)
         CALL GSPOS(CNAME,1,'MAST',X,Y,Z,IROT,'ONLY')         
         CALL GSATT(CNAME,'SEEN',1)
         DO 102   IL=1,NLAYMU
            WRITE(CNAME2,'(''MB'',2I1)'')') IS,IL
            PAR(1) = BWIDMU(IS)/2.
            PAR(2) = BTHKMU(IS)/2./FLOAT(NLAYMU) * 0.95
            PAR(3) = BLNGMU(IS)/2.
            CALL GSVOLU(CNAME2,'BOX ',ICO2I,PAR,3,IVOLU)
            Y = BTHKMU(IS)/2.
     &        * ( -1. + (2.*FLOAT(IL)-1.)/FLOAT(NLAYMU) )
            CALL GSPOS(CNAME2,IL,CNAME,0.,Y,0.,0,'ONLY')
            IF (IL.LE.2) THEN
               IAX = 3
               NDIV=NINT(BLNGMU(IS)/WCELMU)
            ELSE
               IAX = 1
               NDIV=NINT(BWIDMU(IS)/WCELMU)
            ENDIF   
            WRITE(CNAME3,'(''M'',2I1,''C'')') IS,IL
            CALL GSDVN(CNAME3,CNAME2, NDIV, IAX)
            CHNMMU(2) = CNAME2
            CHNMMU(3) = CNAME3
*-- Assign detector to the set MU and defines its basic params.
            IDTYPE = NDETJM*IDETMU+10*IS+IL
            CALL GSDET('MU  ',
     &           CNAME3,NDSVMU,CHNMMU,NBITSV,IDTYPE,NHMXMU,0,
     &           ISET,IDET)
*-- Define hit parameters for detector of set BM.
            CALL GSDETH('MU  ',CNAME3,NDHTMU,CHNMUH,NBITSH,ORIG,FACT)
            VNAMMU(IL,IS) = CNAME3
            
 102     CONTINUE
 101  CONTINUE

      RETURN
      END
