      SUBROUTINE MUHITS
*.
*...MUHITS   Store HITS for the central tracker
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GCSETS GCKINE GCTRAK GCONST CTHIT
*. CALLS     : UHTOC  GFPARA GMTOD  GSAHIT
*. CALLED    : GUSTEP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : J.Kanzaki
*. VERSION   : 1.00
*. CREATED   : 27-Jan-1999
*. LAST MOD  : 27-Jan-1999
*.
*. MODIFICATION LOG
*.
*.**********************************************************************
*
*--   HITS(1): Wire No. 
*--         = (drift cell #)*1000+(super layer phi)
*--   HITS(2): left-right ambiguity ,
*--            +1=+phi side of anode wire,-1=-phi
*--   HITS(3): Particle code
*--   HITS(4): Drift length
*--   HITS(5): X position
*--   HITS(6): Y position
*--   HITS(7): Z position
*--   HITS(8): Time of fright (nsec)
*--   HITS(9): Px
*--   HITS(10): Py
*--   HITS(11): Pz
*--   HITS(12): Drift time
*--   HITS(13): Energy Deposit
*--   HITS(6),(7),(8),(9),(10),(11),(12) are the average of incident 
*--   point & outgoing point of current volume.
      IMPLICIT NONE

*--   Common for GEANT
#include "geant321/gcsets.inc"
#include "geant321/gckine.inc"
#include "geant321/gctrak.inc"
#include "geant321/gconst.inc"
#include "geant321/gckmax.inc"
#include "geant321/gcking.inc"

#include "jmdet.inc"

#include "mugeo.inc"
#include "muhit.inc"

      REAL HITS(NDHTMU)
      SAVE HITS
      
      INTEGER ITROLD
      DATA ITROLD / -1 /
      SAVE ITROLD

      INTEGER IHIT


      IF (ISIMJD(IDETMU).EQ.ISKPJD) RETURN
      
c      if (charge.ne.0.) then
c      if (istak.ne.0) then
c      if (istak.ne.0 .and. charge.ne.0.) then
c      print *,' '
c      print *,'cthits;itra,istak,charge = ',itra,istak,charge
c      print *,'      ;ipart,ivert = ',ipart,ivert
c      print *,'      ;inwvol,istop,destep = ',inwvol,istop,destep
c      print *,'      ;nstep,getot,gekin = ',nstep,getot,gekin
c      print *,'      ;x,y,z = ',vect(1),vect(2),vect(3)
c      endif
*-- Only charged particle
      IF (CHARGE .EQ. 0.0) GOTO 999

*-- Calculate positions etc. only when particle enters or exits the cell,
*-- or new particle is generated, or the particle stoped.
      IF (INWVOL.NE.1 .AND. INWVOL.NE.2 .AND. ISTOP.NE.2) RETURN

*-- Track has entered a new volume or it is a new track
      IF (INWVOL.EQ.1) THEN
         HITS(1) = IPART
         
*-- Fill drift length & left-right ambiguity
         HITS(2) = VECT(1)
         HITS(3) = VECT(2)
         HITS(4) = VECT(3)
         HITS(5) = VECT(7)
         HITS(6) = VECT(4)*VECT(7)
         HITS(7) = VECT(5)*VECT(7)
         HITS(8) = VECT(6)*VECT(7)
         HITS(9) = TOFG*10**9
C        WRITE(6,*) 'IN',HITSIN(2),HITSIN(3),HITSIN(5),HITSIN(7)
         
*-- Track is exiting from the current volume or stops.
      ELSEIF (INWVOL.EQ.2 .OR. ISTOP.EQ.2) THEN

         HITS(10)=VECT(1)
         HITS(11)=VECT(2)
         HITS(12)=VECT(3)
         HITS(13)=VECT(7)
         HITS(14)=VECT(4)*VECT(7)
         HITS(15)=VECT(5)*VECT(7)
         HITS(16)=VECT(6)*VECT(7)
         HITS(17)=TOFG*10**9
         
*-- Stores element values for current hit into data structure JHITS.
         IF (ITRA.NE.ITROLD) THEN
            CALL GSAHIT(ISET,IDET,10000*ISTAK+ITRA,NUMBV,HITS,IHIT)
            ITROLD = ITRA
         ELSE 
            CALL GSCHIT(ISET,IDET,10000*ISTAK+ITRA,NUMBV,HITS,1,IHIT)
         ENDIF

      ENDIF

  999 CONTINUE
      RETURN
      END
