      SUBROUTINE SMDEDX(KE,M,A,Z,DENS,UDEDX)
*     KE is kinetic energy (unit for KE and M should be MeV)
*
      IMPLICIT NONE
      
      REAL  KE,M,A,Z,DENS,UDEDX

      DOUBLE PRECISION K,ZC,ME,IP,SIGMA
      PARAMETER (K=0.307075D0)
      PARAMETER (ZC=1.D0)
*-- MeV
      PARAMETER (ME=0.511D0)
*-- MeV
      PARAMETER (IP=11.0D-06)
*-- density effect ~ 0
      PARAMETER (SIGMA=0.0)
      
      DOUBLE PRECISION E0,P0,BETA,GAMMA
      DOUBLE PRECISION U,TMAX,S,D

      E0=M+KE
      P0=DSQRT(E0**2-M**2)
      BETA = P0/E0
      GAMMA= E0/M

*-- for density=1g/cm^3
      U = K*ZC**2*Z/A/BETA**2 
      
      TMAX = 2.*ME*BETA**2*GAMMA**2/(1.+2.*GAMMA*ME/M+(ME/M)**2)
      S = 0.5*DLOG((2.*ME*BETA**2*GAMMA**2*TMAX)/IP**2)-BETA**2-SIGMA/2.

      D = U * S * DENS
      UDEDX = D

      RETURN
      END
