      SUBROUTINE SMIDEP(XS1,XS2,RINTEG)
*   HADRON INTERACXTION
*   integrated rate of energy in depth from XS1 to XS2 
*   XS1 XS2 can be negative (backward)
*   XS1 XS2   (cm)
      
      IMPLICIT NONE
      REAL XS1,XS2,RINTEG

      REAL X1,X2

      DOUBLE PRECISION PF(7),PB(7),U1,U2,XX
      SAVE PF,PB

      DATA PF /
C     &   .158546697348D-01,
     &    0.D+01,
     &   .480414591730D-01,
     &  -.187561300118D-02,
     &   .453288594144D-04,
     &  -.630493616427D-06,
     &   .454788029458D-08,
     &  -.131122612768D-10/
       
      DATA PB /
     &   .643655890599D-03,
     &   .116758293007D-02,
     &   .966022435023D-05,
     &  -.206435515793D-05,
     &   .639843307226D-07,
     &  -.877035111202D-09,
     &   .469713330731D-11/
      REAL       PBDAMP
      PARAMETER (PBDAMP = 7.0)

      INTEGER I


      X1=MIN(XS1,XS2)
      X2=MAX(XS1,XS2)

      IF (X1.LT.0. .AND. X2.LT.0.) THEN
         U1 = 0.0
         U2 = 0.0
         XX = ABS(X1)
         IF (XX.GT.100.) XX=100.
         DO 100 I=1,7
            U1 = U1 + PF(I)*(XX/PBDAMP)**(I-1)
 100     CONTINUE
         U1=DSQRT(U1)
         XX = ABS(X2)
         IF (XX.GT.100.) XX=100.
         DO 110 I=1,7
            U2 = U2 + PF(I)*(XX/PBDAMP)**(I-1)
 110     CONTINUE 
         U2=DSQRT(U2)
         RINTEG = U1-U2
      ELSEIF (X1.LT.0..AND.X2.GE.0.) THEN
         U1 = 0.0
         U2 = 0.0
         XX = ABS(X1)
         IF (XX.GT.100.) XX=100.
         DO 120 I=1,7
            U1 = U1 + PF(I)*(XX/PBDAMP)**(I-1)
 120     CONTINUE 
         U1=DSQRT(U1)
         XX = ABS(X2)
         IF (XX.GT.100.) XX=100.
         DO 130 I=1,7
            U2 = U2 + PF(I)*XX**(I-1)
 130     CONTINUE 
         U2=DSQRT(U2)
         RINTEG = U1+U2
      ELSEIF (X1.GE.0..AND.X2.GE.0.) THEN
         U1 = 0.0
         U2 = 0.0
         XX = ABS(X1)
         IF (XX.GT.100.) XX=100.
         DO 140 I=1,7
            U1 = U1 + PF(I)*XX**(I-1)
 140     CONTINUE
         U1=DSQRT(U1)
         XX = ABS(X2)
         IF (XX.GT.100.) XX=100.
         DO 150 I=1,7
            U2 = U2 + PF(I)*XX**(I-1)
 150     CONTINUE
         U2=DSQRT(U2)
         RINTEG = U2-U1
      ELSE
         RINTEG = 0.0
      ENDIF
      
      RETURN
      END
