      REAL FUNCTION SMRN2E(RANG,M)
*---- EK calculation from RANGE (kinetic energy)
*---- unit : EK,M   GeV          RANGE  cm
*---- availabel upto beta*gamma=100
      
      IMPLICIT NONE
      REAL  EK,M,RANG

      REAL CUT1,CUT2,CUT3,CUT4,CUT5
      PARAMETER (CUT1=0.01, CUT2=0.05, CUT3=1.0, CUT4=40.0, CUT5=500.0 ) 
      REAL P1(4),P2(4),P3(5),P4(6),P5(4),P6(4)
      SAVE P1,P2,P3,P4,P5,P6 
      DATA P1 /    .27352E-01,  20.289, -1378.9,  36169. / 
      DATA P2 /   .87350E-01,  4.8342 ,   -77.656,  553.03 /
      DATA P3 /  .16373, .98389, -1.8289, 1.9030 , -.74922/
      DATA P4 /  .37542,.10939,-.71824E-02,.30499E-03,
     &                               -.62827E-05,.49211E-07/ 
      DATA P5 /  1.0105,.18729E-01,-.81686E-05, .96948E-08/
      DATA P6 /  .92279 ,.16689E-01,.10129E-05, -.62429E-10 /

      REAL RNORM,BTGM,PTOT,ETOT


      RNORM = RANG/M

      IF (RNORM.LT.CUT1) THEN
         BTGM=P1(1)+P1(2)*RNORM+P1(3)*RNORM**2+P1(4)*RNORM**3
      ELSEIF (RNORM.LT.CUT2) THEN
         BTGM=P2(1)+P2(2)*RNORM+P2(3)*RNORM**2+P2(4)*RNORM**3
      ELSEIF (RNORM.LT.CUT3) THEN
         BTGM=P3(1)+P3(2)*RNORM+P3(3)*RNORM**2+P3(4)*RNORM**3+
     &                                         P3(5)*RNORM**4
      ELSEIF (RNORM.LT.CUT4) THEN
         BTGM=P4(1)+P4(2)*RNORM+P4(3)*RNORM**2+P4(4)*RNORM**3+
     &                          P4(5)*RNORM**4+P4(6)*RNORM**5
      ELSEIF (RNORM.LT.CUT5) THEN
         BTGM=P5(1)+P5(2)*RNORM+P5(3)*RNORM**2+P5(4)*RNORM**3
      ELSE
         BTGM=P6(1)+P6(2)*RNORM+P6(3)*RNORM**2+P6(4)*RNORM**3
      ENDIF
      BTGM=MAX(0.0,BTGM)
      PTOT=BTGM*M
      ETOT=SQRT(PTOT**2+M**2)
      EK=ETOT-M
      SMRN2E = EK

      RETURN
      END
