      SUBROUTINE VXFFRD
*.
*...VXFFRD   Read VX geometry data
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : GEFILE
*. CALLS     : FFSET  FFKEY  FFGO
*. CALLED    : UGINIT
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Naoyasu HOSODA
*. VERSION   : 1.00
*. CREATED   : 18-May-1994
*. LAST MOD  : 11-May-1995
*.
*. MODIFICATION LOG
*. 11-May-1995 Nakamura.I ,Replace DYALLC with JUALLC
*. 27-May-1994 N.Hosoda, Add find data file name part
*. 15-JUN-1994 N.Hosoda, Use GETDID
*. 28-Jun-1994 N.Hosoda, Use not OPEN but DYALLC
*. 25-Apr-1995 Y.Fujii,  Add DLTKVX=Depletion Layer Thickness
*. 15-Dec-1998 A.Miyamoto, Number of VX layer (MLAYVX) can be up to 6.
*.
*.**********************************************************************
      IMPLICIT NONE

*--   Common for user
#include "jmdet.inc"
#include "vxgeo.inc"
#include "vxsim.inc"

      SITKVX = 300.E-4
      DLTKVX = 30.E-4
      PXCLVX = 25.E-4

      NLAYVX = 4

      RVX(1) = 2.4
      RVX(2) = 3.6
      RVX(3) = 4.8
      RVX(4) = 6.0

      ZVX(1) = 5.0
      ZVX(2) = 7.5
      ZVX(3) = 10.0
      ZVX(4) = 12.5

C      RVX(1) = 2.5
C      RVX(2) = 4.5
C      RVX(3) = 6.5
C      RVX(4) = 8.5

C      ZVX(1) = 7.5
C      ZVX(2) = 13.5
C      ZVX(3) = 19.5
C      ZVX(4) = 25.5
      
      IBNKVX = ISBKVX

      IF (LUNMJD(IDETVX).LE.0) RETURN

*--   Set optional values
      CALL FFSET('LINP', LUNMJD(IDETVX))

*--   Define private data records
      CALL FFKEY('SITK', SITKVX , 1, 'REAL')
      CALL FFKEY('DLTK', DLTKVX , 1, 'REAL')
      CALL FFKEY('PXCL', PXCLVX , 1, 'REAL')
      CALL FFKEY('NLAY', NLAYVX , 1, 'INTEGER')
      CALL FFKEY('RVX ', RVX    , MLAYVX, 'REAL')
      CALL FFKEY('ZVX ', ZVX    , MLAYVX, 'REAL')

      CALL FFKEY('BSIZ', IBNKVX, 1, 'INTEGER')

*--   Read data cards
      CALL FFGO

  999 CONTINUE
      RETURN
      END
