      SUBROUTINE VXSPAR
*.
*...VXSPAR   Saves Vertex Detector Parameters into ZBS Bank.
*.           
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : 
*. CALLS     : 
*. CALLED    : JMSAVP
*.
*. BANKS L   :
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Nakamura Isamu
*. VERSION   : 1.00
*. CREATED   : 3-Aug-1994
*. LAST MOD  : 
*.
*. MODIFICATION LOG
*. 15-Oct-1999  J.Kanzaki
*.              add bank size parameter
*. 25-Apr-1995  Y.Fujii, Add DLTKVX(Depletion Layer Thickness)=DATA(2).
*.                       SITKVX(originaly DATA(2)) moved to DATA(10).
*.
*.**********************************************************************
      IMPLICIT NONE

#include "vxgeo.inc"
#include "vxsim.inc"
      
      INTEGER NPDATA
      PARAMETER (NPDATA=20)
      INTEGER IDATA(NPDATA)
      REAL    RDATA(NPDATA)
      EQUIVALENCE (RDATA(1),IDATA(1))

      INTEGER NWMAST,NSEGM,LSEGM
      PARAMETER (NWMAST=17, NSEGM=0, LSEGM=0)
      CHARACTER*32 CFMAST, CFSEGM
      PARAMETER (CFMAST='1I 15F 1I', CFSEGM=' ')

      INTEGER IERR

*-- Create ZBS Bank MCVXPAR
      CALL KZBCR1('MCVXPAR',NWMAST,CFMAST,NSEGM,LSEGM,CFSEGM,IERR)

*-- Store Data to given Segment of Bank MCVXPAR
      IDATA(1)  = NLAYVX
      RDATA(2)  = DLTKVX
      RDATA(3)  = PXCLVX
      RDATA(4)  = RVX(1)
      RDATA(5)  = RVX(2)
      RDATA(6)  = RVX(3)
      RDATA(7)  = RVX(4)
      RDATA(8)  = RVX(5)
      RDATA(9)  = RVX(6)
      RDATA(10) = ZVX(1)
      RDATA(11) = ZVX(2)
      RDATA(12) = ZVX(3)
      RDATA(13) = ZVX(4)
      RDATA(14) = ZVX(5)
      RDATA(15) = ZVX(6)
      RDATA(16) = SITKVX
      IDATA(17) = IBNKVX

      CALL KZREP1('MCVXPAR',0,NWMAST,IDATA)

      RETURN
      END
