      SUBROUTINE JLGECP(ICODE)

      IMPLICIT NONE

#include "buffer.inc"
#include "ecgeo.inc"
#include "calpos.inc"

      INTEGER ICODE,I,IR,IP,IREM

      REAL VPOS(6),RDIS,TANT,RSZE,RSZH,PSZE,PSZH
      REAL ERAW,COST,ECOR(4)
      REAL PI,TWOPI
      PARAMETER (PI=3.14159265358979323846, TWOPI=PI*2)

      INTEGER LBANK

      CALL KZEFST

      ICODE = 0

      CALL KZBLOC('MCECPAR',LBANK)
      IF (LBANK.LE.0) THEN
         CALL MSGOUT('JLGECP','MCECPAR does not exist',LBANK)
         ICODE = 1
         RETURN
      ENDIF

* Get informations from the JIM bank

      CALL KZGET('MCECPAR', 0, NBUFF, IBUFF )
      SWITEC = IBUFF(1)
      NDREC  = IBUFF(2)
      RI1EC  = RBUFF(3)
      RO1EC  = RBUFF(4)
      RI2EC  = RBUFF(5)
      RO2EC  = RBUFF(6)
      ZIEC   = RBUFF(7)
      BLEC   = RBUFF(8)
      DEMEC  = RBUFF(9)
      TSCEEC = RBUFF(10)
      TSCHEC = RBUFF(11)
      BSIZEC = RBUFF(12)
      DO 51   I=1,NDREC
         CALL KZGET('MCECPAR', I, NBUFF, IBUFF )
         NDPEC(I) = IBUFF(1)
 51   CONTINUE

* Calculation of CELL position and calibration factor

* Init.
      CALL VZERO(ECEPOS,6*NEERAD*NEEPHI*2)
      CALL VZERO(ECHPOS,6*NEHRAD*NEHPHI*2)
      CALL VZERO(EEFACT,4*NEERAD)
      CALL VZERO(EHFACT,4*NEHRAD)
      
      TANT = (RO2EC-RO1EC)/BLEC      
      RSZE = (RO1EC-RI1EC+DEMEC/2.*TANT)/(2*NDREC)
      RSZH = (RO1EC-RI1EC+(DEMEC+BLEC)/2.*TANT)/NDREC

* EE
      DO 101 IR=1,NEERAD
         IF(IR.GE.1.AND.IR.LE.2*NDREC+4) THEN
            VPOS(3) = ZIEC+DEMEC/4.
            RDIS = RI1EC+RSZE*(IR-0.5)
            VPOS(4) = SQRT(RDIS**2+VPOS(3)**2)
            VPOS(5) = ATAN2(RDIS,VPOS(3))
            IREM=NINT((IR+0.5)/2.)
            IF(IREM.GT.NDREC) IREM=NDREC
            PSZE = TWOPI/(2*NDPEC(IREM))
         ELSE
            GOTO 101
         ENDIF

* defined calibration factor
      
         ERAW=1.0
         COST=COS(VPOS(5))
         CALL CALIB(COST,ERAW,ECOR)
         EEFACT(1,IR)=ECOR(1)
         EEFACT(2,IR)=ECOR(2)
         EEFACT(3,IR)=ECOR(3)
         EEFACT(4,IR)=ECOR(4)
        
* PHI loop
      
         DO 102 IP=1,NEEPHI
            IF(IP.GE.1.AND.IP.LE.2*NDPEC(IREM)) THEN
               VPOS(6) = PSZE*(IP-0.5)            
               VPOS(1) = RDIS*COS(VPOS(6))
               VPOS(2) = RDIS*SIN(VPOS(6))
               ECEPOS(1,IR,IP,1) = VPOS(1)
               ECEPOS(2,IR,IP,1) = VPOS(2)
               ECEPOS(3,IR,IP,1) = VPOS(3)
               ECEPOS(4,IR,IP,1) = VPOS(4)
               ECEPOS(5,IR,IP,1) = VPOS(5)
               ECEPOS(6,IR,IP,1) = ATAN2(VPOS(2),VPOS(1))             
               ECEPOS(1,IR,IP,2) = VPOS(1)
               ECEPOS(2,IR,IP,2) = VPOS(2)
               ECEPOS(3,IR,IP,2) = -1.0*VPOS(3)
               ECEPOS(4,IR,IP,2) = VPOS(4)
               ECEPOS(5,IR,IP,2) = ABS(PI-VPOS(5))
               ECEPOS(6,IR,IP,2) = ECEPOS(6,IR,IP,1)
            ENDIF
 102     CONTINUE
 101  CONTINUE
     
* EH
      DO 111 IR=1,NEHRAD
         IF(IR.GE.1.AND.IR.LE.NDREC+2) THEN
            VPOS(3) = ZIEC+BLEC/2.
            RDIS = RI1EC+RSZH*(IR-0.5)
            VPOS(4) = SQRT(RDIS**2+VPOS(3)**2)
            VPOS(5) = ATAN2(RDIS,VPOS(3))
            IREM=IR
            IF(IREM.GT.NDREC) IREM=NDREC
            PSZH = TWOPI/NDPEC(IREM)
         ELSE
            GOTO 111
         ENDIF

* defined calibration factor
      
         ERAW=1.0
         COST=COS(VPOS(5))
         CALL CALIB(COST,ERAW,ECOR)
         EHFACT(1,IR)=ECOR(1)
         EHFACT(2,IR)=ECOR(2)
         EHFACT(3,IR)=ECOR(3)
         EHFACT(4,IR)=ECOR(4)
        
* PHI loop
      
         DO 112 IP=1,NEHPHI
            IF(IP.GE.1.AND.IP.LE.NDPEC(IREM)) THEN
               VPOS(6) = PSZH*(IP-0.5)
               VPOS(1) = RDIS*COS(VPOS(6))
               VPOS(2) = RDIS*SIN(VPOS(6))
               ECHPOS(1,IR,IP,1) = VPOS(1)
               ECHPOS(2,IR,IP,1) = VPOS(2)
               ECHPOS(3,IR,IP,1) = VPOS(3)
               ECHPOS(4,IR,IP,1) = VPOS(4)
               ECHPOS(5,IR,IP,1) = VPOS(5)
               ECHPOS(6,IR,IP,1) = ATAN2(VPOS(2),VPOS(1))             
               ECHPOS(1,IR,IP,2) = VPOS(1)
               ECHPOS(2,IR,IP,2) = VPOS(2)
               ECHPOS(3,IR,IP,2) = -1.0*VPOS(3)
               ECHPOS(4,IR,IP,2) = VPOS(4)
               ECHPOS(5,IR,IP,2) = ABS(PI-VPOS(5))
               ECHPOS(6,IR,IP,2) = ECHPOS(6,IR,IP,1)
            ENDIF
 112     CONTINUE
 111  CONTINUE

      RETURN
      END
