      SUBROUTINE DMTINV(ARRAY,NORDER)
*.
*...DMTINV   Invert a symmetric matrix with DOUBLE PRECISION data.
*.
*.  INPUT    : ARRAY   matrix with DOUBLE PRECISION data
*.           : NORDER  dimension of the matrix (<= 15)
*.  OUTPUT   : ARRAY   inverted matrix
*.
*. AUTHOR    : J. Kanzaki
*. VERSION   :
*. CREATED   : 20-Aug-1982
*. LAST MOD  : 06-Mar-1996
*.
*. HISTORY   :
*. 02-Aug-1988 : Dimension declaration of the input matrix is changed
*.             : by T.Tsuboyama.
*. 06-Mar-1996 : Subroutine name is changed from FMTINV to DMTINV
*.             : All variables are declared
*.             : by J. Kanzaki
************************************************************************

      IMPLICIT NONE
      INTEGER NPRMAX
      PARAMETER (NPRMAX=15)
      INTEGER NORDER
      DOUBLE PRECISION ARRAY(NORDER,NORDER)
      DOUBLE PRECISION AMAX,SAVE
      INTEGER IK(NPRMAX),JK(NPRMAX)

      INTEGER I,J,K,L

      DO 100 K=1,NORDER

      AMAX=0.

   20 DO 30 I=K,NORDER
      DO 30 J=K,NORDER
      IF (DABS(ARRAY(I,J)).GE.DABS(AMAX)) THEN
         AMAX=ARRAY(I,J)
         IK(K)=I
         JK(K)=J
      ENDIF
   30 CONTINUE

      IF (AMAX.EQ.0.0) RETURN

      I=IK(K)
      IF (I.LT.K) GOTO 20

      IF (I.NE.K) THEN
         DO 50 J=1,NORDER
         SAVE=ARRAY(K,J)
         ARRAY(K,J)=ARRAY(I,J)
         ARRAY(I,J)=-SAVE
   50    CONTINUE
      ENDIF

      J=JK(K)
      IF (J.LT.K) GOTO 20

      IF (J.NE.K) THEN
         DO 60 I=1,NORDER
         SAVE =ARRAY(I,K)
         ARRAY(I,K)=ARRAY(I,J)
         ARRAY(I,J)=-SAVE
   60    CONTINUE
      ENDIF

      DO 70 I=1,NORDER
      IF (I.NE.K) ARRAY(I,K)=-ARRAY(I,K)/AMAX
   70 CONTINUE

      DO 80 I=1,NORDER
      DO 80 J=1,NORDER
      IF (I.NE.K .AND. J.NE.K)
     &     ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)
   80 CONTINUE

      DO 90 J=1,NORDER
      IF (J.NE.K) ARRAY(K,J)=ARRAY(K,J)/AMAX
   90 CONTINUE

      ARRAY(K,K)=1./AMAX
  100 CONTINUE

      DO 130 L=1,NORDER
      K=NORDER-L+1
      J=IK(K)

      IF (J.GT.K) THEN
         DO 110 I=1,NORDER
         SAVE=ARRAY(I,K)
         ARRAY(I,K)=-ARRAY(I,J)
         ARRAY(I,J)=SAVE
  110    CONTINUE
      ENDIF

      I=JK(K)

      IF (I.GT.K) THEN
         DO 120  J=1,NORDER
         SAVE=ARRAY(K,J)
         ARRAY(K,J)=-ARRAY(I,J)
         ARRAY(I,J)=SAVE
  120    CONTINUE
      ENDIF

 130  CONTINUE
      RETURN
      END
