C   05/08/85 511082232 MEMBER NAME  GMPHI    (S)           FORTRAN
**********************************************************************
*     ---------------------------------
      REAL FUNCTION GMPHI0(X1,Y1,X2,Y2)
*     ---------------------------------
*
*     (Purpose)
*        Calculate azimuthal angle among two points.
*
*     (Input)
*        X1,Y1 : coordinate of the first point
*        X2,Y2 : coordinate of the second point
*
*     (Output)
*        GMPHI : azimuthal angle measured from the first point
*              : the second point.
*
**********************************************************************
      IMPLICIT NONE

      REAL X1,Y1,X2,Y2

      DOUBLE PRECISION DX1,DY1,DX2,DY2
      DOUBLE PRECISION DS,DC
      DOUBLE PRECISION DAS,DAC


      DX1=X1
      DY1=Y1
      DX2=X2
      DY2=Y2

      DS=(DX1*DY2-DY1*DX2)/DSQRT(DX1**2+DY1**2)/DSQRT(DX2**2+DY2**2)
      DC=(DX1*DX2+DY1*DY2)/DSQRT(DX1**2+DY1**2)/DSQRT(DX2**2+DY2**2)

      DAS=DASIN(DS)
      DAC=DACOS(DC)

      IF(DS.GE.0. .AND. DC.GE.0.) THEN
         GMPHI0=DAS
      ELSE IF(DS.GE.0. .AND. DC.LT.0.) THEN
         GMPHI0=DAC
      ELSE IF(DS.LT.0. .AND. DC.GE.0.) THEN
         GMPHI0=DAS
      ELSE
         GMPHI0=-DAC
      END IF

      RETURN
      END
