************************************************************************
*     ---------------------------------------
      SUBROUTINE JUALLC(ILUN,CDSN,IFORM,IERR)
*     ----------------------------------------
*
*     (Purpose)
*        Open a file dynamically using OPEN statement.  You can both
*        read and write to the opened file.
*
*     (Memo)
*        This routine does not allow you to create new file.  This
*        menas that the file you want to open must be exist before
*        you call this routine.
*
*     (Input)
*        ILUN  ; Logical unit# assign to the file/
*        CDSN  ; Character string which specify the DSN.
*              ; You are allowed to put spaces between characters in
*                this string - routine automatically compress spaces.
*        IFORM =  0 ; FORMATTED file
*              =  1 ; UNFORMATTED file
*              = -1 ; Direct Access file
*
*      ( IACT is obsolete 95.05.11
*      ( IACT  = 1 ; READ only
*      (       = 2 ; WRITE only
*      (       = other values ; READ and WRITE
*
*     (Output)
*        IERR  ; IOSTAT value will be return if there is an error.
*
*     (History)
*        1984.12.11 : First version by J.Kanzaki.
*        1985.03.09 ; Character compress function has been added. AMAKO
*        1985.03.18 ; Modified so that READ/WRITE can be possible. AMAKO
*        1999.03.01 ; Add DIRECT ACCESS mode by J.Kanzaki
*
************************************************************************
*
*        STATUS argument in OPEN statement is changed changed
*        from 'OLD' to 'SHR', so that users can access
*        data sets which belong to other users from FORTRAN
*        program.
*                                      1985.10.14  J.Kanzaki
*
************************************************************************
*
*        Changes for WS version:
*           ACTION arguments is obsolete.
*           
*                                      1994.06.08  J.Kanzaki
*
************************************************************************
*
*        Change subroutine name from DYALLC to JUALLC for JLC usage.
*        Remove IACT (for ACTION) from the argument list.
*           
*                                      1995.05.11  J.Kanzaki
*
************************************************************************
*           
*                                      1999.03.01  J.Kanzaki
*
************************************************************************

      CHARACTER*(*) CDSN

      PARAMETER (MAXSTR=120)
      CHARACTER*(MAXSTR) STRING
      CHARACTER*80 ARGUM1,ARGUM2
      CHARACTER*1 SPACE

      INTEGER LNBLNK
      DATA SPACE/' '/


***** Initialization

      IERR=0
      IOSTAT=0
C      STRING=CDSN

***** Compress string CDSN so that there is no space in file name

C      MAXCH=LEN(CDSN)
C      IF(MAXCH.GT.MAXSTR) GOTO 40

C      DO 30 NCH=1,MAXCH-1
C         NSPACE=0
C         NCH1=NCH

C   10    IF(STRING(NCH1:NCH1).EQ.SPACE) THEN
C            NSPACE=NSPACE+1
C            NCH1=NCH1+1
C            IF(NCH1.GT.MAXCH) GOTO 40
C            GOTO 10
C          END IF

C          IF(NSPACE.GE.1) THEN
C             DO 20 I=NCH,MAXCH-1
C                IF(I+NSPACE.LE.MAXCH) THEN
C                   STRING(I:I)=STRING(I+NSPACE:I+NSPACE)
C                ELSE
C                   STRING(I:I)=SPACE
C                END IF
C   20        CONTINUE
C         END IF

C   30 CONTINUE


***** Open file

40    CONTINUE

      IF(IFORM.EQ.0) THEN
         ARGUM1='FORMATTED'
      ELSEIF(IFORM.EQ.1 .OR. IFORM.EQ.-1) THEN
         ARGUM1='UNFORMATTED'
      ELSE
         ARGUM1='UNFORMATTED'
      END IF

      IF(IFORM.EQ.0 .OR. IFORM.EQ.1) THEN
         ARGUM2='SEQUENTIAL'
      ELSE IF(IFORM.EQ.-1) THEN
         ARGUM2='DIRECT'
      ELSE
         ARGUM2='SEQUENTIAL'
      END IF


      OPEN(ILUN,FILE=CDSN(1:LNBLNK(CDSN)),
     &     ACCESS=ARGUM2,
     &     STATUS='UNKNOWN',
     &     FORM=ARGUM1,
     &     IOSTAT=IOSTAT,ERR=100)

      RETURN

  100 CONTINUE

      IERR=IOSTAT

      RETURN
      END
