************************************************************************
*     -------------------------------
      SUBROUTINE SORTFK(A,K,M,LIST,N)
*     -------------------------------
*
*     (Purpose)
*        Sort two dimensional floating point data in ascending order
*        by using "Quick-sort" algorithm.
*
*     (Input)
*        A    : 2-dim. array of data
*        K    : position of the data to be sorted
*        M    : width of the array
*        LIST : array of pointers
*        N    : number of data
*
************************************************************************
      IMPLICIT NONE

      INTEGER K,M,N
      REAL  A(M,N)
      INTEGER LIST(N)

      INTEGER NPSAVE
      PARAMETER (NPSAVE=100)
      INTEGER ILSAVE(NPSAVE),IRSAVE(NPSAVE)
      
      INTEGER IL,IR,IS
      REAL AL
      INTEGER I,J,ITEMP


      DO 100 I=1,N
         LIST(I)=I
  100 CONTINUE

      IF(N.LE.1) RETURN

      IS=0

      IL=1
      IR=N

 10   CONTINUE
      I=IL
      J=IR+1

      AL=A(K,LIST(IL))

 20   CONTINUE 
      J=J-1

      IF(AL.LT.A(K,LIST(J))) GO TO 20
      
 30   CONTINUE 
      I=I+1

      IF(I.GE.J) GO TO 40

      IF(A(K,LIST(I)).LT.AL) GO TO 30

      IF(I.LT.J) THEN

         ITEMP=LIST(I)
         LIST(I)=LIST(J)
         LIST(J)=ITEMP

         GO TO 20

      END IF
      
 40   CONTINUE 
      IF(IL.LT.J) THEN

         ITEMP=LIST(IL)
         LIST(IL)=LIST(J)
         LIST(J)=ITEMP

      END IF

      IF(J+1.LT.IR) THEN

         IS=IS+1

         ILSAVE(IS)=J+1
         IRSAVE(IS)=IR

      END IF

      IF(J-IL.GT.1) THEN

         IR=J-1

         GO TO 10

      END IF

      IF(IS.GT.0) THEN

         IL=ILSAVE(IS)
         IR=IRSAVE(IS)
         IS=IS-1

         GO TO 10

      END IF

      RETURN
      END
