C   17/11/92 211170059  MEMBER NAME  UP2HLX   (S)        M  FORTRAN
CC********************************************************************CC
C*                                                                    *C
C*===============================----===                              *C
C*  Subroutine UP2HLX(XV,PV,ICHG,HELX)                                *C
C*===============================----===                              *C
C*                                                                    *C
C* (Purpose)                                                          *C
C*    Convert XV, PV to standard helix parametrization.               *C
C*    deflection angle.                                               *C
C* (Inputs)                                                           *C
C*      XV  (*)     : (R*4) ; positon vector.                         *C
C*      PV  (*)     : (R*4) ; momentum vector.                        *C
C*      ICHG        : (I*4) ; charge ( must be +/- 1 ).               *C
C* (Outputs)                                                          *C
C*      HELX(*)     : (R*4) ; helix parameters.                       *C
C*                            1-st 8 words in                         *C
C*                            Production:TPC;Track_Parameter.         *C
C* (Relation)                                                         *C
C*    Calls no subroutines.                                           *C
C* (Update Record)                                                    *C
*.    29-May-95 Nakamura.I  Bug which returns infinite number is fixed.
C*    5/31/88  K.Fujii        Original version.                       *C
C*                                                                    *C
CC********************************************************************CC

      SUBROUTINE UP2HLX(XV,PV,ICHG,HELX)

      IMPLICIT NONE
      INTEGER ICHG
      REAL XV(3), PV(3), HELX(8)

      REAL PX, PY, PZ, PT
C
C========< Entry Point >================================================
C
C--
C  Calculate FI0, CPA, TNL assuming XV as the pivot.
C--
      PX      = PV(1)
      PY      = PV(2)
      PZ      = PV(3)
      PT      = SQRT(PX*PX+PY*PY)
C--
C      WRITE(*,*) ICHG,PT
      HELX(1) = 0
      IF(PT.LE.0.) THEN
         PT= 1.0E-9
         HELX(2) = 0.
         HELX(3) = FLOAT(ICHG)/PT
      ELSE
         HELX(2) = ATAN2(-PX,PY)
         HELX(3) = FLOAT(ICHG)/PT
      ENDIF
      HELX(4) = 0
      HELX(5) = PZ/PT
      CALL UCOPY(XV,HELX(6),3)
C--
C  That's it.
C--
      RETURN
      END
