      SUBROUTINE GETTRK
*.
*...GETCTT   stores 'TRACK' bank information from 'CTTRACK' bank
*.
*. INPUT     : none
*. OUTPUT    : none
*.
*. SEQUENCE  :
*. COMMON    : CTGEO  GCNUM
*. CALLS     : KZGET1 KZGET0
*. CALLED    : GUANAL
*.
*. BANKS L   : CTTRACK
*. BANKS U   :
*. BANKS M   :
*. BANKS D   :
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : Junichi KANZAKI
*. VERSION   : 1.00
*. CREATED   : 13-Mar-1996
*. LAST MOD  : 13-Mar-1996
*.
*. MODIFICATION LOG
*.**********************************************************************
      IMPLICIT NONE
      
#include "jlcnst.inc"      
#include "jlfeld.inc"
#include "jlcylp.inc"
#include "trbuff.inc"
#include "ctgeo.inc"
#include "buffer.inc"

      INTEGER NDPMOM
      PARAMETER (NDPMOM=5)
      REAL PMOM(NDPMOM)
      INTEGER ICHARG,IFLAG

      INTEGER LSECTR,LSDCTR
      PARAMETER (LSECTR=44)
      PARAMETER (LSDCTR=LSECTR/2)
      REAL RDACTR(LSECTR)
      DOUBLE PRECISION DDACTR(LSDCTR)
      INTEGER IDACTR(LSECTR)
      EQUIVALENCE (RDACTR(1),IDACTR(1))

      INTEGER ITR

      REAL PHI,PHI0,RC,RMIN
      REAL X0,Y0,Z0
      REAL XC,YC
      REAL RDIST
      REAL SMIN,ZMIN,DZDS
      REAL STEMP

      INTEGER NHITRP,NHITRZ

      REAL HELX(8),XP(3)
      REAL EPSL
      PARAMETER (EPSL=0.1)
      INTEGER IRET

      INTEGER NTR
      REAL RHIT,COSTH,THETA

      INTEGER I

      integer j


      CALL KZEFST

      CALL KZGET('CTTRACK', 0, NBUFF, IBUFF)

      NTR = IBUFF(1)
      NTRK = 0

c      print *,'gettrk;ntr = ',ntr
      DO 100 ITR=1,NTR
         
         CALL CTPMOM(ITR,PMOM,ICHARG,IFLAG)
         IF (IFLAG.GE.0) THEN
            
            NTRK = NTRK+1

*-- Px,Py,Pz at closest aproach
            TRKF( 1,NTRK) = PMOM(1)
            TRKF( 2,NTRK) = PMOM(2)
            TRKF( 3,NTRK) = PMOM(3)
c            print *,'gettrk;itr,ntrk = ',itr,ntrk
c            print *,'gettrk;px,py,pz = ',pmom(1),pmom(2),pmom(3)
*-- Pabs
            TRKF( 4,NTRK) = PMOM(4)
*-- Charge
            TRKF( 8,NTRK) = ICHARG
            
            CALL KZGET('CTTRACK',ITR,NBUFF,IDACTR)
c            do j=1,14
c               print *,'j,rdactr = ',j,rdactr(j)
c            enddo
c            do j=8,22
c               print *,'j,ddactr = ',j,ddactr(j)
c            enddo
          
*-- Generator track number
            TRKF( 9,NTRK) = IDACTR(13)
            
*-- Pivot coordinate
            TRKF(15,NTRK) = 0.
            TRKF(16,NTRK) = 0.
            TRKF(17,NTRK) = 0.
            
*-- Track parameters
            PHI0 = RDACTR(2)
            RC = 1./ABS(RDACTR(3))
            PHI = PHI0-SIGN(1.,RDACTR(3))*(0.5*XPI)
            X0 = RMIN*COS(PHI)
            Y0 = RMIN*SIN(PHI)
            RDIST = RC - RMIN
            XC = RDIST*COS(PHI)
            YC = RDIST*SIN(PHI)
c            print *,'xc,yc,rc,x0,y0 = ',xc,yc,rc,x0,y0 
            CALL CTSLEN(XC,YC,RC,X0,Y0,0.,0., SMIN, STEMP)
            ZMIN = RDACTR(6)
            DZDS = RDACTR(7)
c            print *,'gettrk;zmin,dzds,smin = ',zmin,dzds,smin
            Z0   = ZMIN+DZDS*SMIN
            
            TRKF(10,NTRK) = RDACTR(1)
            TRKF(11,NTRK) = PHI
            TRKF(12,NTRK) = RDACTR(3)*PTOR
            TRKF(13,NTRK) = RDACTR(6)
            TRKF(14,NTRK) = RDACTR(7)
            
            TRKF(5,NTRK) = X0
            TRKF(6,NTRK) = Y0
            TRKF(7,NTRK) = Z0
            
            NHITRP = IDACTR(6)
            NHITRZ = IDACTR(9)
            
            TRKF(18,NTRK) = NHITRP+NHITRZ-5
            
            DO 110 I=1,15
               TRKD(I,NTRK) = DDACTR(I+7)
 110        CONTINUE
            
            TRKD(4,NTRK) = PTOR * TRKD(4,NTRK)
            TRKD(5,NTRK) = PTOR * TRKD(5,NTRK)
            TRKD(6,NTRK) = PTOR**2 * TRKD(6,NTRK)

            TRKD(9,NTRK) = PTOR * TRKD(9,NTRK)
            TRKD(13,NTRK) = PTOR * TRKD(13,NTRK)

            HELX(1) = RDACTR(2)
            HELX(2) = PHI
            HELX(3) = RDACTR(3)*PTOR
            HELX(4) = RDACTR(6)
            HELX(5) = RDACTR(7)
            HELX(6) = X0
            HELX(7) = Y0
            HELX(8) = Z0
            
            CALL UHLXCY(REMC, ZEMC, EPSL, HELX, PHI, XP, IRET)
            
            RHIT = SQRT(XP(1)**2+XP(2)**2)
            COSTH = XP(3)/SQRT(XP(1)**2+XP(2)**2+XP(3)**2)
            THETA = ACOS(COSTH)
            PHI = ATAN2(XP(2),XP(1))
            TRKF(19,NTRK) = RHIT
            TRKF(21,NTRK) = THETA
            TRKF(22,NTRK) = PHI
            
            NVTX(NTRK) = 0

c         do j=1,npftrk
c            print *,'gettrk;trkf(',j,',',ntrk,') = ',trkf(j,ntrk)
c         enddo

c         do j=1,npdtrk
c            print *,'gettrk;trkd(',j,',',ntrk,') = ',trkd(j,ntrk)
c         enddo

         ENDIF
         
 100  CONTINUE

      RETURN
      END
