************************************************************************
*     --------------------------------------------------------------
      SUBROUTINE KZCRBN(ITYPE,IBANK,CNAME,NWMAST,NWSMST,NSEGM,LSEGM)
*     --------------------------------------------------------------
*
*     (Purpose)
*        Create bank index record.
*
*     (Inputs)
*        LTYPE  ; Type of ZBS bank structure
*        IBANK  ; Entry position of bank directory
*        CNAME  ; Name of the entry ( <= 32 characters).
*
*     (Output)
*        LBIR   ; Address of the created bank index record.
*
*     (Creation Date)
*        1991.12.25 : First version by J.Kanzaki.
*        1996.04.26 : Add declarations by J.Kanzaki
*        1999.03.02 : J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbs.inc"
#include "zbssys.inc"

      INTEGER ITYPE,IBANK,NWMAST,NSEGM,NWSMST,LSEGM
      CHARACTER*(*) CNAME

      INTEGER NLBIR,NSBIR,IOBIR
      PARAMETER (NLBIR=3,NSBIR=3,IOBIR=2)
      INTEGER NDBIR

      INTEGER NLNAME,NSNAME,IONAME
      PARAMETER (NLNAME=0,NSNAME=0,IONAME=5)
      INTEGER NDNAME
      PARAMETER (NDNAME=LBNAME)
      
      INTEGER INAME(LBNAME)
      INTEGER LNAME

      INTEGER LEVC,LEMB,LEHD,LBIR,LIND
      INTEGER LLAST
      INTEGER IXEVTD
      INTEGER LZLAST

      INTEGER I


      CALL VBLANK(INAME,LBNAME)
      CALL UCTOH(CNAME,INAME,4,LEN(CNAME))
      
      LEVC = LZBS(IPEVC)
      LEMB = LZBS(LEVC-ILEMCR)
      LEHD = LZBS(LEMB-ILEHCR)
      
      LLAST = LZLAST(IXSTOR,LZBS(LEHD-ILBILS))
      
      IXEVTD = IXDIV(2)
      IF (ITYPE.EQ.0) THEN
         NDBIR = LINDHD + LINDSG*(NSEGM0+1)
      ELSEIF (ITYPE.EQ.1) THEN
         NDBIR = LINDHD
      ELSEIF (ITYPE.EQ.2) THEN
         NDBIR = LINDHD + LINDSG*(NSEGM+1)
      ENDIF
      
      IF(LLAST.NE.0) THEN
         
         CALL MZBOOK(IXEVTD,LZBS(IBANK),LLAST,0,
     &        CNAME(1:4),NLBIR,NSBIR,NDBIR,IOBIR,0)
       
      ELSE
         
         CALL MZBOOK(IXEVTD,LZBS(IBANK),LEHD,-ILBILS,
     &        CNAME(1:4),NLBIR,NSBIR,NDBIR,IOBIR,0)
         
      END IF
      
      LBIR = LZBS(IBANK)
      
*-- Create space for bank names
      CALL MZBOOK(IXEVTD,LNAME,LBIR,-ILNAME,
     &     CNAME(1:4),NLNAME,NSNAME,NDNAME,IONAME,0)
      
      DO 10 I=1,LBNAME
         IZBS(LNAME+I) = INAME(I)
 10   CONTINUE
      
C**** space for a bank type
      
      IZBS(LBIR+IBKTYP)=ITYPE
      
      IF (ITYPE.EQ.0) THEN
         
         IZBS(LBIR+ILDTRC) = LDTRC0
         IZBS(LBIR+ILFILL) = 0
         IZBS(LBIR+INEXDT) = 0
         IZBS(LBIR+ILDTR1) = NINT(FDTRC1*REAL(LDTRC0))
         IZBS(LBIR+INSEGM) = NSEGM0
         IZBS(LBIR+INSGMX) = -1
         IZBS(LBIR+IISLST) = 0
         IZBS(LBIR+INEXSG) = 0
         IZBS(LBIR+INSGM1) = NINT(FSEGM1*REAL(NSEGM0))
         IZBS(LBIR+INSMST) = 0

      ELSEIF (ITYPE.EQ.1) THEN

         IZBS(LBIR+ILDTRC) = 0
         IZBS(LBIR+ILFILL) = 0
         IZBS(LBIR+INEXDT) = 0
         IZBS(LBIR+ILDTR1) = 0
         IF(NSEGM.GT.0) THEN
            IZBS(LBIR+INSEGM) = NSEGM
            IZBS(LBIR+INSGM1) = MAX(NINT(FSEGM1*REAL(NSEGM)),1)
         ELSE IF(LSEGM.GT.0) THEN
            IZBS(LBIR+INSEGM) = NSEGM0
            IZBS(LBIR+INSGM1) = NINT(FSEGM1*REAL(NSEGM0))
         ELSE
            IZBS(LBIR+INSEGM) = 0
            IZBS(LBIR+INSGM1) = 0
         END IF
         IZBS(LBIR+INSGMX) = -1
         IZBS(LBIR+IISLST) = 0
         IZBS(LBIR+INEXSG) = 0
         
         IZBS(LBIR+INMAST) = NWMAST
         IZBS(LBIR+ILSEGF) = LSEGM
         IZBS(LBIR+INSMST) = 0

      ELSEIF (ITYPE.EQ.2) THEN

         DO 20 I=0,NSEGM
            LIND=LBIR+LINDHD+I*LINDSG
            IF(I.EQ.0) THEN
               IZBS(LIND+1)=0
               IZBS(LIND+2)=0
            ELSE
               IZBS(LIND+1)=-1
               IZBS(LIND+2)=0
            END IF
 20      CONTINUE
         
         IZBS(LBIR+ILDTRC) = NWMAST+LDTRC0
         IZBS(LBIR+ILFILL) = NWMAST
         IZBS(LBIR+INEXDT) = 0
         IZBS(LBIR+ILDTR1) = NINT(FDTRC1*REAL(LDTRC0))
         IZBS(LBIR+INSEGM) = NSEGM
         IZBS(LBIR+INSGMX) = -1
         IZBS(LBIR+IISLST) = 0
         IZBS(LBIR+INEXSG) = 0
         IZBS(LBIR+INSGM1) = 0
         
         IZBS(LBIR+INMAST) = NWMAST
         IZBS(LBIR+ILSEGF) = LSEGM
         IZBS(LBIR+INSMST) = NWSMST

      ENDIF

      RETURN
      END
