************************************************************************
*     -----------------------------------------------
      SUBROUTINE KZGET2(CNAME,ISEGM,ISSEG,NDATA,IDATA)
*     -----------------------------------------------
*
*     (Purpose)
*       Get the contents of the bank with the specified segment# 
*
*     (Input)
*       CNAME ; The name of the bank
*       ISEGM ; Segment number
*
*     (Output)
*       NDATA ; Length ot the data
*       IDATA(i) ; Contents of the segment
*
*     (Creation Date and Author)
*       1992.12.22 ; First version by J.Kanzaki
*       1996.04.26 : Add declarations.  J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbs.inc"
#include "zbssys.inc"

      CHARACTER*(*) CNAME
      INTEGER ISEGM,ISSEG,NDATA,IDATA(*)

      INTEGER LBIR,IPDATA,ITYPE
      INTEGER NSEGM,NWMAST,NWSMST,LSEGM,LDATA,IPSEG,LSMST
      INTEGER NSSEG,IDAT


      NDATA = 0

      CALL KZBLOC(CNAME, LBIR)

      IF (LBIR.LE.0) RETURN

      IF (ISEGM.LT.0) RETURN

      IPDATA=LZBS(LBIR-ILDATR)
      IF (LBIR.LE.0 .OR. IPDATA.LE.0) RETURN
      
      ITYPE=IZBS(LBIR+IBKTYP)
      IF (ITYPE.NE.2) RETURN
      
      NSEGM=IZBS(LBIR+INSEGM)
      IF (NSEGM.LT.ISEGM) RETURN
      
      NWMAST = IZBS(LBIR+INMAST)
      NWSMST = IZBS(LBIR+INSMST)
      LSEGM  = IZBS(LBIR+ILSEGF)
      
      IF (ISEGM.LT.0 .OR. ISEGM.GT.NSEGM) THEN
         CALL MSGOUT('KZGETP','Illegal Segment# specified',
     &        ISEGM)
         RETURN
      END IF
      
      IF (ISEGM.EQ.0) THEN
*-- Access to Master Segment
         NDATA = NWMAST
         LDATA = IPDATA
      ELSEIF (ISSEG.GT.0) THEN
*-- Access to Segment with sub-segment#.ne.0
         IPSEG=IZBS(LBIR+LINDHD+ISEGM*LINDSG+1)
         NSSEG=IZBS(LBIR+LINDHD+ISEGM*LINDSG+2)
         IF (ISSEG.LE.0 .OR. ISSEG.GT.NSSEG) RETURN
         NDATA = LSEGM
         LDATA = IPDATA + IPSEG + LSEGM * (ISSEG-1)
      ELSEIF (ISSEG.EQ.0) THEN
         LSMST=LZBS(LBIR-ILSMST)
         IF (LSMST.LE.0) RETURN
         NDATA = NWSMST
         LDATA = LSMST+NWSMST*(ISEGM-1)
      END IF
      
      DO 100 IDAT=1,NDATA
         IDATA(IDAT) = IZBS(LDATA+IDAT)
 100  CONTINUE

      RETURN
      END
