************************************************************************
*     ------------------------------
      INTEGER FUNCTION KZNAME(CNAME)
*     -----------------------------
*
*     (Purpose)
*       Searches for the entry with a specified name, CNAME,
*       from the bank directory table.
*
*     (Input)
*       CNAME ; Name of the bank
*
*     (Output)
*       KZNAME ; Pointer to the bank sort table.
*              ; If the name, CNAME, has been already registered into the
*              ; name table,
*              ;  = position of that bank in the sort table
*              ; If not,
*              ;  = - ( position in the sort table just after the bank,
*              ;        CNAME, to be stored )
*
*     (Creation Date and Author)
*       1991.12.25 : First version by J.Kanzaki
*       1996.04.26 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbs.inc"
#include "zbssys.inc"

      CHARACTER*(*) CNAME

      INTEGER INAME(LBNAME),LNAME(LBNAME)

      INTEGER LDIR,LSRT
      INTEGER NBANK
      INTEGER IPLOW,IPHIG
      INTEGER ICOMP,IP

      INTEGER KZCMPN

      INTEGER I,K


      KZNAME=0

      LDIR=LZBS(IPDIRT)

      NBANK=IZBS(LDIR+INBANK)
      IF (NBANK.LE.0) THEN
         KZNAME=-1
         RETURN
      END IF
      
      CALL VBLANK(INAME,LBNAME)
      CALL UCTOH(CNAME,INAME,4,LEN(CNAME))
      
      DO 10 I=1,LBNAME
         LNAME(I) = LZBS(LDIR-I)
 10   CONTINUE
      LSRT = LZBS(LDIR-ILBSRT)
      
      IPLOW = 1
      IPHIG = NBANK
      
 20   IF (IPLOW.GT.IPHIG) GO TO 100
      IP = (IPLOW+IPHIG)/2
      K = IZBS(LSRT+IP)
      ICOMP = KZCMPN(LNAME,K,INAME)
      IF (ICOMP.LE.0) IPHIG = IP-1
      IF (ICOMP.GE.0) IPLOW = IP+1

      GO TO 20
      
 100  K = IZBS(LSRT+IP)
      ICOMP = KZCMPN(LNAME,K,INAME)
      IF (ICOMP.EQ.0) THEN
         KZNAME = IP
      ELSEIF (ICOMP.LT.0) THEN
         KZNAME = -IP
      ELSE
         KZNAME = -IP-1
      END IF

      RETURN
      END
