************************************************************************
*     -----------------------------------
      SUBROUTINE KZNSSG(CNAME,ISEGM,NSSEGM)
*     -----------------------------------
*
*     (Purpose)
*       Get the number of sub-segments of the specified segment
*       for 2-dim. fixed banks.
*
*     (Input)
*       CNAME ; The name of the bank
*       ISEGM ; Segment #
*
*     (Output)
*       NSSEGM  ; No. of sub-segments
*
*     (Creation Date and Author)
*       1993.07.16 ; First version by J.Kanzaki
*       1996.04.27 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbssys.inc"
#include "zbs.inc"

      CHARACTER*(*) CNAME
      INTEGER ISEGM,NSSEGM

      INTEGER LBIR,ITYPE,NSEGM,LIND


      CALL KZBLOC(CNAME, LBIR)

      NSSEGM = -1

      IF(LBIR.LE.0) RETURN

      ITYPE = IZBS(LBIR+IBKTYP)

      IF(ITYPE.NE.2) RETURN

      NSEGM=IZBS(LBIR+INSEGM)

      IF(ISEGM.LE.0 .OR. ISEGM.GT.NSEGM) RETURN

      LIND=LBIR+LINDHD+ISEGM*LINDSG
      NSSEGM=IZBS(LIND+2)

      RETURN
      END
