************************************************************************
*     -----------------------------------------------------
      SUBROUTINE KZPUT0(CNAME,ISEGM,NWPOS,CFORM,NDATA,IDATA)
*     -----------------------------------------------------
*
*     (Purpose)
*       Put data words into the given segment of the bank.
*
*     (Input)
*       CNAME ; The name of the bank
*       ISEGM ; Segment#
*       NWPOS ; The position ( no. of words ) where the data
*             ; should be replaced.
*       CFORM ; I/O format word in a character
*       NDATA ; Length of the data
*       IDATA ; Data words to be added
*
*     (Output)
*       none
*
*     (Creation Date and Author)
*       1991.12.25 ; First version by J.Kanzaki
*       1996.04.26 : Add declarations. J.Kanzaki
*
************************************************************************

#include "zbsdeclr.inc"
#include "zbs.inc"
#include "zbssys.inc"

      CHARACTER*(*) CNAME
      INTEGER ISEGM,NWPOS,NDATA,IDATA(*)
      CHARACTER*1 CFORM

      INTEGER LBIR,LDATA,IOWORD,ITYPE
      INTEGER NSEGM,LDTR,LDTREC,LFILLD

      INTEGER IFORM
      INTEGER LPOS0,NSSEG0,IFORM0,LSSEG0,LPSSG0
      INTEGER LPOS1,NSSEG1,IFORM1,LSSEG1,LPSSG1

      INTEGER I

      INTEGER KZIOFM


      CALL KZBLOC(CNAME, LBIR)

      LDATA = NDATA+1
      IOWORD = 16*NDATA+KZIOFM(CFORM)

      ITYPE = IZBS(LBIR+IBKTYP)

      IF(ITYPE.NE.0) RETURN

      NSEGM=IZBS(LBIR+INSEGM)

      IF(ISEGM.LT.0) THEN
         CALL MSGOUT('KZPUT0',
     &        'Illegal segment# is specified',1)
         RETURN
      END IF

      IF(ISEGM.GT.NSEGM) CALL KZEXB0(LBIR,ISEGM)

      IF(ISEGM.GT.IZBS(LBIR+INSGMX)) IZBS(LBIR+INSGMX)=ISEGM

      LDTR=LZBS(LBIR-ILDATR)

      LDTREC=IZBS(LBIR+ILDTRC)
      LFILLD=IZBS(LBIR+ILFILL)

      IF(LFILLD+LDATA.GT.LDTREC) CALL KZEXDR(LBIR,LDATA)

      LDTR=LZBS(LBIR-ILDATR)

      IFORM = KZIOFM(CFORM)

      CALL KZWPS0(LBIR,ISEGM,NWPOS+1, 
     &            LPOS0,NSSEG0,IFORM0,LSSEG0,LPSSG0)
      CALL KZWPS0(LBIR,ISEGM,NWPOS+LDATA, 
     &            LPOS1,NSSEG1,IFORM1,LSSEG1,LPSSG1)

C      IF(LPOS.LT.0) THEN
C         CALL MSGOUT('KZPUT0',
C     &        'Insert position location error',2)
C         RETURN
C      END IF

      IF(NSSEG0.EQ.NSSEG1 .AND. IFORM.EQ.IFORM0) THEN

         DO 100 I=1,NDATA
         IZBS(LDTR+LPOS0+I)=IDATA(I)
  100    CONTINUE

      END IF

      RETURN
      END
